
/*==============================================================================
 *
 * (#)Options.java
 * created      2003/03/26
 * version      $Revision: 1.16 $Date: 2004/05/25 01:23:13 $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *==============================================================================
 */

package com.miami.romeo.main;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import com.miami.romeo.config.*;
import com.miami.romeo.xmame.*;
import com.miami.romeo.main.table.IndicatorCellRenderer;


/**
 * Panel containing game options.
 */
public class Options extends JPanel {
  Romeo romeo = null;
  Utils utils = new Utils();
  Config config = null;
  Xmame xmame = null;
  IndicatorCellRenderer iRenderer = null;

  JPanel panel                = null;
  JPanel panel2               = null;
  JPanel centerPanel          = null;
  JLabel label                = null;
  ChangeListener sListener    = null;
  
  // Parameters to pass to MAME
  String gameOptions     = new String();
  String gameName        = new String();
  String mamePath        = new String();
  String romPath         = new String();

  boolean iconifyWindows = false;

  // If checked Romeo will run a game with default options
  JCheckBox defaultBox        = null;
  JCheckBox cheatBox          = null;
  String cheat                = "";

  // Buttons to run a game and to save game options
  JButton runRom              = null;
  JButton saveOptions         = null;

  /* MAME core sound options */
  public JComboBox dspBox     = null;
  String dsp                  = "";
  JCheckBox timerBox          = null;
  String timer                = " -timer";
  public JComboBox mixerBox   = null;
  String mixer                = "";
  JCheckBox soundBox          = null;
  String sound                = " -sound";
  JCheckBox samplesBox        = null;
  String samples              = " -samples";
  JCheckBox fakesoundBox      = null;
  String fakesound            = "";
  JComboBox samplefreqBox     = null;
  String samplefreq           = "";
  JTextField bufsizeField     = null;
  String bufsize              = "";
  JSlider volumeBox           = null;
  String volume               = " -volume 0";
  JTextField audiodeviceField = null;
  String audiodevice          = "";
  JTextField mixerdeviceField = null;
  String mixerdevice          = "";
  JCheckBox resamplefilterBox = null;
  String resamplefilter       = " -resamplefilter";

  JPanel audioPanel           = null;

  /* Video options */
  JTextField arbheightField   = null;
  String arbheight            = " -arbheight 0";
  JSlider heightscaleBox      = null;
  String heightscale          = "";
  JSlider widthscaleBox       = null;
  String widthscale           = "";
  JCheckBox autoframeskipBox  = null;
  String autoframeskip        = " -autoframeskip";
  JComboBox frameskipTypeBox  = null;
  String frameskipType        = " -frameskipper 0";
  ButtonGroup frameskipGroup  = null;
  JTextField frameskipField   = null;
  String frameskip            = " -frameskip 8";
  JCheckBox windowBox         = null;
  String window               = "";
  JCheckBox scanlinesBox      = null;
  String scanlines            = " -noscanlines";
  JCheckBox throttleBox       = null;
  String throttle             = " -throttle";
  JComboBox effectBox         = null;
  String effect               = "";
  JCheckBox autodoubleBox     = null;
  String autodouble           = " -noautodouble";
  JSpinner gammaBox           = null;
  JLabel btl                  = null;
  String gamma                = "";
  JSlider brightnessBox       = null;
  String brightness           = "";
  JTextField geometryField    = null;
  String geometry             = "";

  /* Display Related */
  JCheckBox rotateBox   = null;
  String rotate         = " -norotate";
  JCheckBox autororBox  = null;
  String autoror        = "";
  JCheckBox autorolBox  = null;
  String autorol        = "";
  JCheckBox rorBox      = null;
  String ror            = "";
  JCheckBox rolBox      = null;
  String rol            = "";
  JCheckBox flipxBox    = null;
  String flipx          = "";
  JCheckBox flipyBox    = null;
  String flipy          = "";
  
  /* Artwork Related */
  JCheckBox artworkBox         = null;
  String artwork               = " -artwork";
  JCheckBox backdropBox        = null;
  String backdrop              = " -backdrop";
  JCheckBox overlayBox         = null;
  String overlay               = " -overlay";
  JCheckBox bezelBox           = null;
  String bezel                 = " -bezel";
  JCheckBox cropBox            = null;
  String crop                  = " -noartcrop";
  JTextField aresolutionField  = null;
  String artworkresolution     = " -artres 0";

  /* Vector Games Related */
  JTextField vectorresField  = null;
  String vectorres        = "";
  JSlider beamBox         = null;
  String beam             = " -beam 1";
  JSlider flickerBox      = null;
  String flicker          = " -flicker 0";
  JSlider intensityBox    = null;
  String intensity        = " -intensity 1.5";
  JCheckBox antialiasBox  = null;
  String antialias        = " -antialias";
  JCheckBox tlucencyBox   = null;
  String translucency     = " -translucency";

  /* Input device options */
  JCheckBox mouseBox          = null;
  String mouse                = " -nomouse";
  JComboBox joytypeBox        = null;
  String joytype              = " -joytype 0";
  JCheckBox joystickBox       = null;
  String joystick             = "";
  JCheckBox steadykeyBox      = null;
  String steadykey            = "";
  JCheckBox keyboardledsBox   = null;
  String keyboardleds         = "";
  JComboBox ctrlrBox          = null;
  String ctrlr                = "";
  JTextField joydevnameField  = null;
  String joydevname           = "";
  JCheckBox analogstickBox    = null;
  String analogstick          = "";
  JCheckBox hotrodBox         = null;
  String hotrod               = "";
  JCheckBox hotrodseBox       = null;
  String hotrodse             = "";
  JCheckBox usbpspadBox       = null;
  String usbpspad             = "";
  JCheckBox rapidfireBox      = null;
  String rapidfire            = "";

  /**
   * Constructor.
   *
   * @param romeo The caller 
   */
  public Options(Romeo romeo) {
    this.romeo = romeo;

    setLayout(new BorderLayout());

    add(createNorthPanel(), BorderLayout.NORTH);

    JScrollPane sp = new JScrollPane(createCenterPanel(),
                                     JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                                     JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    sp.setBorder(BorderFactory.createEmptyBorder(0, 0, 0,0));

    add(sp, BorderLayout.CENTER);
  }

  /**
   * This method returns a panel.
   *
   * @return <code>JPanel</code>
   *
   * @see    #enableAll(boolean)
   */
  public JPanel createNorthPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    defaultBox = new JCheckBox();
    defaultBox.setText(utils.getString("Options.jcheckbox_default"));
    defaultBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        enableAll(e.getStateChange() == ItemEvent.SELECTED);
      }
    });

    panel.add(defaultBox);
    panel.add(Box.createHorizontalStrut(10));

    cheatBox = new JCheckBox();
    cheatBox.setText("Cheat subsystem");
    cheatBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          cheat = " -cheat";
        else
          cheat = "";
      }
    });
    panel.add(cheatBox);
    panel.add(Box.createHorizontalStrut(10));

    runRom = new JButton();
    runRom.setIcon(utils.createImageIcon24x24("Exec.png"));
    runRom.setToolTipText(utils.getString("Options.play"));
    runRom.setMinimumSize(new Dimension(40, 40));
    runRom.setPreferredSize(new Dimension(40, 40));
    runRom.setMaximumSize(new Dimension(40, 40));
    runRom.addActionListener(new PlayGameAction(this));
    panel.add(runRom);
    panel.add(Box.createHorizontalStrut(10));

    saveOptions = new JButton();
    saveOptions.setIcon(utils.createImageIcon24x24("Save.png"));
    saveOptions.setToolTipText(utils.getString("Options.save"));
    saveOptions.setMinimumSize(new Dimension(40, 40));
    saveOptions.setPreferredSize(new Dimension(40, 40));
    saveOptions.setMaximumSize(new Dimension(40, 40));
    saveOptions.addActionListener(new SaveYourOptionsAction(this));
    panel.add(saveOptions);

    return panel;
  }

  /**
   * This method returns a panel.
   *
   * @return <code>JPanel</code>
   *
   * @see    #createWindowsAudioPanel()
   * @see    #createLinuxAudioPanel()
   * @see    #createWindowsVideoPanel()
   * @see    #createLinuxVideoPanel()
   * @see    #createArtworkOptionsPanel()
   * @see    #createDisplayRotationPanel()
   * @see    #createWindowsInputPanel()
   * @see    #createLinuxInputPanel()
   * @see    #createVectorGamesOptionsPanel()
   */
  public JPanel createCenterPanel() {
    centerPanel = new JPanel(new BorderLayout());
    centerPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    String OS = System.getProperty("os.name").toLowerCase();
    // System.out.println(OS);
    if (OS.indexOf("windows") > -1) {
      this.window = " -nowindow";

      centerPanel.add(createWindowsAudioPanel(), BorderLayout.WEST);

      JPanel videoPanel = new JPanel();
      videoPanel.setLayout(new GridLayout(1, 3));
      videoPanel.setBorder(BorderFactory.createTitledBorder(
                                          utils.getString("Options.video")));

      JPanel videoPanel1 = new JPanel();
      videoPanel1.setLayout(new GridLayout(1, 1));
      videoPanel1.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 5));
      videoPanel1.add(createWindowsVideoPanel());
      videoPanel.add(videoPanel1);

      JPanel videoPanel2 = new JPanel();
      videoPanel2.setLayout(new GridLayout(2, 1));
      videoPanel2.setBorder(BorderFactory.createEmptyBorder(10, 5, 10, 5));
      videoPanel2.add(createArtworkOptionsPanel());
      videoPanel2.add(createDisplayRotationPanel());
      videoPanel.add(videoPanel2);

      JPanel videoPanel3 = new JPanel();
      videoPanel3.setLayout(new GridLayout(2, 1));
      videoPanel3.setBorder(BorderFactory.createEmptyBorder(10, 5, 10, 10));
      videoPanel3.add(createWindowsInputPanel());
      videoPanel3.add(createVectorGamesOptionsPanel());
      videoPanel.add(videoPanel3);

      centerPanel.add(videoPanel, BorderLayout.CENTER);
    }
    else {
      centerPanel.add(createLinuxAudioPanel(), BorderLayout.WEST);

      JPanel videoPanel = new JPanel();
      videoPanel.setLayout(new GridLayout(1, 3));
      videoPanel.setBorder(BorderFactory.createTitledBorder(
                                          utils.getString("Options.video")));

      JPanel videoPanel1 = new JPanel();
      videoPanel1.setLayout(new GridLayout(1, 1));
      videoPanel1.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 5));
      videoPanel1.add(createLinuxVideoPanel());
      videoPanel.add(videoPanel1);

      JPanel videoPanel2 = new JPanel();
      videoPanel2.setLayout(new GridLayout(2, 1));
      videoPanel2.setBorder(BorderFactory.createEmptyBorder(10, 5, 10, 5));
      videoPanel2.add(createArtworkOptionsPanel());
      videoPanel2.add(createDisplayRotationPanel());
      videoPanel.add(videoPanel2);

      JPanel videoPanel3 = new JPanel();
      videoPanel3.setLayout(new GridLayout(2, 1));
      videoPanel3.setBorder(BorderFactory.createEmptyBorder(10, 5, 10, 10));
      videoPanel3.add(createLinuxInputPanel());
      videoPanel3.add(createVectorGamesOptionsPanel());
      videoPanel.add(videoPanel3);

      centerPanel.add(videoPanel, BorderLayout.CENTER);
    }

    return centerPanel;
  }

  /**
   * This method returns a panel containing audio options for the
   * Windows command line.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3pre3
   */
  public JPanel createWindowsAudioPanel() { 
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    soundBox = new JCheckBox();
    soundBox.setAlignmentX(LEFT_ALIGNMENT);
    soundBox.setText(utils.getString("Options.sound"));
    soundBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          sound = " -sound";
        else
          sound = " -nosound";
      }
    });

    samplesBox = new JCheckBox();
    samplesBox.setAlignmentX(LEFT_ALIGNMENT);
    samplesBox.setText(utils.getString("Options.samples"));
    samplesBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          samples = " -samples";
        else
          samples = " -nosamples";
      }
    });

    JLabel vl = new JLabel(utils.getString("Options.volume") + " 0");
    vl.setAlignmentX(LEFT_ALIGNMENT);

    volumeBox = new JSlider(-32, 0, 0);
    volumeBox.setAlignmentX(LEFT_ALIGNMENT);
    volumeBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    volumeBox.setPaintTicks(true);
    volumeBox.setMajorTickSpacing(1);
    sListener = new SliderListener(vl);
    volumeBox.addChangeListener(sListener);

    String[] rate = {" 11025", " 22050", " 44100", " 48000"};

    samplefreqBox = new JComboBox(rate);
    samplefreqBox.setAlignmentX(LEFT_ALIGNMENT);
    samplefreqBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	samplefreq = " -samplerate " + cb.getSelectedItem().toString();
      }
    });

    resamplefilterBox = new JCheckBox();
    resamplefilterBox.setAlignmentX(LEFT_ALIGNMENT);
    resamplefilterBox.setText("Resample filter");
    resamplefilterBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          resamplefilter = " -resamplefilter";
        else
          resamplefilter = " -noresamplefilter";
      }
    });

    panel.add(soundBox);
    panel.add(samplesBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.samplefreq"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(samplefreqBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.volume"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(volumeBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(resamplefilterBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                                            utils.getString("Options.audio")));
    panel2.add(panel);

    return panel2;
  }

  /**
   * This method returns a panel containing audio options for xmame.
   *
   * @return  <code>JPanel</code>
   *
   * @since 0.1.3pre3
   */
  public JPanel createLinuxAudioPanel() {
    xmame = new Xmame(romeo);
    String xmamePath = romeo.games.getXmamePath();
    
    audioPanel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    audioPanel.setLayout(new BoxLayout(audioPanel, BoxLayout.Y_AXIS));
    audioPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    dspBox = new JComboBox();
    dspBox.setAlignmentX(LEFT_ALIGNMENT);
    dspBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();

	if (!cb.getSelectedItem().toString().equals("<NOT SET>"))
	  dsp = " -dp " + cb.getSelectedItem().toString().trim();
	else
          dsp = "";
      }
    });

    timerBox = new JCheckBox();
    timerBox.setText(utils.getString("Options.timer"));
    timerBox.setAlignmentX(LEFT_ALIGNMENT);
    timerBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          timer = " -timer";
        else
          timer = " -notimer";
      }
    });

    mixerBox = new JComboBox();
    mixerBox.setAlignmentX(LEFT_ALIGNMENT);
    mixerBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();

	if (!cb.getSelectedItem().toString().equals("<NOT SET>"))
	  mixer = " -smp " + cb.getSelectedItem().toString().trim();
	else
          mixer = "";
      }
    });

    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    label = new JLabel(utils.getString("Options.dsp_label"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(dspBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(timerBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.mixer_label"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(mixerBox);
    panel.add(Box.createVerticalStrut(10));

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                                     utils.getString("Options.digital_audio")));
    panel2.add(panel);

    audioPanel.add(panel2);

    soundBox = new JCheckBox();
    soundBox.setAlignmentX(LEFT_ALIGNMENT);
    soundBox.setText(utils.getString("Options.sound"));
    soundBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          sound = " -sound";
        else
          sound = " -nosound";
      }
    });

    samplesBox = new JCheckBox();
    samplesBox.setAlignmentX(LEFT_ALIGNMENT);
    samplesBox.setText(utils.getString("Options.samples"));
    samplesBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          samples = " -samples";
        else
          samples = " -nosamples";
      }
    });

    fakesoundBox = new JCheckBox();
    fakesoundBox.setAlignmentX(LEFT_ALIGNMENT);
    fakesoundBox.setText(utils.getString("Options.fakesound"));
    fakesoundBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          fakesound = " -fakesound";
        else
          fakesound = "";
      }
    });

    JLabel vl = new JLabel(utils.getString("Options.volume") + " 0");
    vl.setAlignmentX(LEFT_ALIGNMENT);

    volumeBox = new JSlider(-32, 0, 0);
    volumeBox.setAlignmentX(LEFT_ALIGNMENT);
    volumeBox.putClientProperty("JSlider.isFilled", Boolean.TRUE);
    volumeBox.setPaintTicks(true);
    volumeBox.setMajorTickSpacing(1);
    sListener = new SliderListener(vl);
    volumeBox.addChangeListener(sListener);

    String[] rate = {" 11025", " 22050", " 44100", " 48000"};

    samplefreqBox = new JComboBox(rate);
    samplefreqBox.setAlignmentX(LEFT_ALIGNMENT);
    samplefreqBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	samplefreq = " -samplefreq " + cb.getSelectedItem().toString();
      }
    });

    bufsizeField = new JTextField();
    bufsizeField.setPreferredSize(new Dimension(150, 24));
    bufsizeField.setAlignmentX(LEFT_ALIGNMENT);
    bufsizeField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == '.') ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    bufsizeField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
          try {
            Float.parseFloat(content);
            bufsize = " -bufsize " + content;
          } catch (NumberFormatException nfe) {
            getToolkit().beep();
            textField.setText("");
            textField.requestFocus();
            JOptionPane.showMessageDialog(null,
                                      utils.getString(
				      "Messagebox.error_novalidfloat"),
                                      utils.getString("Messagebox.error_title"),
                                      JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    });

    audiodeviceField = new JTextField();
    audiodeviceField.setAlignmentX(LEFT_ALIGNMENT);
    audiodeviceField.setPreferredSize(new Dimension(150, 24));
    audiodeviceField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0)
          audiodevice = " -audiodevice " + content;
      }
    });

    mixerdeviceField = new JTextField();
    mixerdeviceField.setPreferredSize(new Dimension(150, 24));
    mixerdeviceField.setAlignmentX(LEFT_ALIGNMENT);
    mixerdeviceField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0)
          mixerdevice = " -mixerdevice " + content;
      }
    });

    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    panel.add(soundBox);
    panel.add(samplesBox);
    panel.add(fakesoundBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.samplefreq"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(samplefreqBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.bufsize"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(bufsizeField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(vl);
    panel.add(volumeBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.audiodevice"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(audiodeviceField);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.mixerdevice"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(mixerdeviceField);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                                           utils.getString("Options.general")));
    panel2.add(panel);

    audioPanel.add(panel2);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                                           utils.getString("Options.audio")));
    panel2.add(audioPanel);

    return panel2;
  }

  /**
   * This method creates a panel containing Windows video options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3pre3
   */
  public JPanel createWindowsVideoPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    
    autoframeskipBox = new JCheckBox();
    autoframeskipBox.setText(utils.getString("Options.autoframeskip"));
    autoframeskipBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          autoframeskip = " -autoframeskip";
        else
          autoframeskip = " -noautoframeskip";
      }
    });

    frameskipField = new JTextField();
    frameskipField.setAlignmentX(LEFT_ALIGNMENT);
    frameskipField.setPreferredSize(new Dimension(150, 24));
    frameskipField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    frameskipField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
          try {
            Integer.parseInt(content);
	    frameskip = " -frameskip " + content;
          } catch (NumberFormatException nfe) {
            getToolkit().beep();
            textField.setText("");
            textField.requestFocus();
	    JOptionPane.showMessageDialog(null,
                               utils.getString("Messagebox.error_novalidint"),
                               utils.getString("Messagebox.error_title"),
                               JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    });

    windowBox = new JCheckBox();
    windowBox.setAlignmentX(LEFT_ALIGNMENT);
    windowBox.setText(utils.getString("Options.fullscreen"));
    windowBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          window = " -nowindow";
        else
          window = " -window";
      }
    });

    throttleBox = new JCheckBox();
    throttleBox.setAlignmentX(LEFT_ALIGNMENT);
    throttleBox.setText(utils.getString("Options.throttle"));
    throttleBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          throttle = " -throttle";
        else
          throttle = " -nothrottle";
      }
    });

    scanlinesBox = new JCheckBox();
    scanlinesBox.setAlignmentX(LEFT_ALIGNMENT);
    scanlinesBox.setText(utils.getString("Options.scanlines"));
    scanlinesBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          throttle = " -scanlines";
        else
          throttle = " -noscanlines";
      }
    });

    String[] effects = {" none", " sharp", " scan25", " scan50",
                        " scan75", " scan75v", " rgb3", " rgb4",
			" rgb4v", " rgb6", " rgb16", " rgbtiny"};

    effectBox = new JComboBox(effects);
    effectBox.setAlignmentX(LEFT_ALIGNMENT);
    effectBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	effect = " -effect " + cb.getSelectedItem().toString();
      }
    });

    final Object[] gamma_values = {"0.5", "0.6", "0.7", "0.8", "0.9", "1.0",
                                   "1.1", "1.2", "1.3", "1.4", "1.5", "1.6",
                 	           "1.7", "1.8", "1.9", "2.0"};

    final SpinnerModel sm = new SpinnerListModel(gamma_values);

    // Create a JSpinner based on a list of strings
    gammaBox = new JSpinner(sm);
    gammaBox.setAlignmentX(LEFT_ALIGNMENT);
    gammaBox.addChangeListener( new ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        gamma = " -gamma " + sm.getValue();
      }
    });

    JScrollPane listScrollPane = new JScrollPane(gammaBox);
    listScrollPane.setAlignmentX(LEFT_ALIGNMENT);

    JLabel btl = new JLabel(utils.getString("Options.brightness") + ": 1.0");
    btl.setAlignmentX(LEFT_ALIGNMENT);

    brightnessBox = new JSlider(5, 20, 10);
    brightnessBox.setAlignmentX(LEFT_ALIGNMENT);
    brightnessBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    sListener = new SliderListener(btl);
    brightnessBox.addChangeListener(sListener);

    panel.add(autoframeskipBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.maxautoframeskip") + ":");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(frameskipField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(windowBox);
    panel.add(throttleBox);
    panel.add(scanlinesBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.videoeffect") + ":");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(effectBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel("gamma:");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(listScrollPane);
    panel.add(Box.createVerticalStrut(10));
    panel.add(btl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(brightnessBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.general")));

    panel2.add(panel);

    return panel2;
  }

  /**
   * This method creates a panel containing xmame video options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3pre3
   */
  public JPanel createLinuxVideoPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    arbheightField = new JTextField();
    arbheightField.setPreferredSize(new Dimension(150, 24));
    arbheightField.setAlignmentX(LEFT_ALIGNMENT);
    arbheightField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    arbheightField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
          try {
            Integer.parseInt(content);
	    arbheight = " -arbheight " + content;
          } catch (NumberFormatException nfe) {
            getToolkit().beep();
            textField.setText("");
            textField.requestFocus();
	    JOptionPane.showMessageDialog(null,
                               utils.getString("Messagebox.error_novalidint"),
                               utils.getString("Messagebox.error_title"),
                               JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    });

    JLabel hl = new JLabel(utils.getString("Options.heightscale") + " " + 1);
    hl.setAlignmentX(LEFT_ALIGNMENT);

    heightscaleBox = new JSlider(1, 5, 1);
    heightscaleBox.setAlignmentX(LEFT_ALIGNMENT);
    heightscaleBox.putClientProperty("JSlider.isFilled", Boolean.TRUE);
    heightscaleBox.setPaintTicks(true);
    heightscaleBox.setMajorTickSpacing(1);
    sListener = new SliderListener(hl);
    heightscaleBox.addChangeListener(sListener);


    JLabel wl = new JLabel(utils.getString("Options.widthscale") + " " + 1);
    wl.setAlignmentX(LEFT_ALIGNMENT);

    widthscaleBox = new JSlider(1, 5, 1);
    widthscaleBox.setAlignmentX(LEFT_ALIGNMENT);
    widthscaleBox.putClientProperty("JSlider.isFilled", Boolean.TRUE);
    widthscaleBox.setPaintTicks(true);
    widthscaleBox.setMajorTickSpacing(1);
    sListener = new SliderListener(wl);
    widthscaleBox.addChangeListener(sListener);

    autoframeskipBox = new JCheckBox();
    autoframeskipBox.setAlignmentX(LEFT_ALIGNMENT);
    autoframeskipBox.setText(utils.getString("Options.autoframeskip"));
    autoframeskipBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          autoframeskip = " -autoframeskip";
        else
          autoframeskip = " -noautoframeskip";
      }
    });
    
    String[] types = {" 0 Dos frameskip code",
                      " 1 Enhanced frameskip code"};

    frameskipTypeBox = new JComboBox(types);
    frameskipTypeBox.setAlignmentX(LEFT_ALIGNMENT);
    frameskipTypeBox.setPreferredSize(new Dimension(150, 24));
    frameskipTypeBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	frameskipType = " -frameskipper " + cb.getSelectedIndex();
      }
    });

    frameskipField = new JTextField();
    frameskipField.setPreferredSize(new Dimension(150, 24));
    frameskipField.setAlignmentX(LEFT_ALIGNMENT);
    frameskipField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    frameskipField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
          try {
            Integer.parseInt(content);
	    frameskip = " -frameskip " + content;
          } catch (NumberFormatException nfe) {
            getToolkit().beep();
            textField.setText("");
            textField.requestFocus();
	    JOptionPane.showMessageDialog(null,
                               utils.getString("Messagebox.error_novalidint"),
                               utils.getString("Messagebox.error_title"),
                               JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    });

    windowBox = new JCheckBox();
    windowBox.setAlignmentX(LEFT_ALIGNMENT);
    windowBox.setText(utils.getString("Options.fullscreen"));
    windowBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        xmame = new Xmame(romeo);

        String version = xmame.getVersion(romeo.games.getXmamePath());
        String versionName = version.substring(version.indexOf('(') + 1,
                                               version.indexOf(')'));

        if (e.getStateChange() == ItemEvent.SELECTED) {
	  if (versionName.equals("SDL"))
            window = " -fullscreen";
          else if (versionName.equals("x11"))
            window = " -x11 1";
	}
	else {
          if (versionName.equals("SDL"))
            window = " -nofullscreen";
          else if (versionName.equals("x11"))
            window = " -x11 0";
        }
      }
    });

    throttleBox = new JCheckBox();
    throttleBox.setAlignmentX(LEFT_ALIGNMENT);
    throttleBox.setText(utils.getString("Options.throttle"));
    throttleBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          throttle = " -throttle";
        else
          throttle = " -nothrottle";
      }
    });

    scanlinesBox = new JCheckBox();
    scanlinesBox.setAlignmentX(LEFT_ALIGNMENT);
    scanlinesBox.setText(utils.getString("Options.scanlines"));
    scanlinesBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          scanlines = " -scanlines";
        else
          scanlines = " -noscanlines";
      }
    });

    String[] effects = {" 0 none (default)", " 1 scale2x (smooth scaling effect)",
                        " 2 scan2 (light scanlines)", " 3 rgbstripe (3x2 rgb vertical stripes)",
			" 4 rgbscan (2x3 rgb horizontal scanlines)", " 5 scan3 (3x3 deluxe scanlines)"};

    effectBox = new JComboBox(effects);
    effectBox.setAlignmentX(LEFT_ALIGNMENT);
    effectBox.setPreferredSize(new Dimension(150, 24));
    effectBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	effect = " -effect " + cb.getSelectedIndex();
      }
    });

    final Object[] gamma_values = {"0.5", "0.6", "0.7", "0.8", "0.9", "1.0",
                                   "1.1", "1.2", "1.3", "1.4", "1.5", "1.6",
                 	           "1.7", "1.8", "1.9", "2.0"};

    final SpinnerModel sm = new SpinnerListModel(gamma_values);

    // Create a JSpinner based on a list of strings
    gammaBox = new JSpinner(sm);
    gammaBox.addChangeListener( new ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        xmame = new Xmame(romeo);

        int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
        int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
        int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

        if (majorNumber == 0 && minorNumber <= 66) {
          if (patchNumber >= 1)
            gamma = " -gamma " + sm.getValue();
          else
            gamma = " -gamma-correction " + sm.getValue();
        }
        else
          gamma = " -gamma " + sm.getValue();
      }
    });

    JScrollPane listScrollPane = new JScrollPane(gammaBox);
    listScrollPane.setAlignmentX(LEFT_ALIGNMENT);

    xmame = new Xmame(romeo);

    int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
    int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
    int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

    if (majorNumber == 0 && minorNumber <= 66) {
      if (patchNumber >= 1) {
        btl = new JLabel(utils.getString("Options.brightness") + ": 1.0");
        brightnessBox = new JSlider(5, 20, 10);
      }
      else {
        btl = new JLabel(utils.getString("Options.brightness") + ": 50%");
        brightnessBox = new JSlider(0, 100, 50);
      }
    }
    else {
      btl = new JLabel(utils.getString("Options.brightness") + ": 1.0");
      brightnessBox = new JSlider(5, 20, 10);
    }


    brightnessBox.setAlignmentX(LEFT_ALIGNMENT);
    brightnessBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    sListener = new SliderListener(btl);
    brightnessBox.addChangeListener(sListener);
    
    geometryField = new JTextField();
    geometryField.setPreferredSize(new Dimension(150, 24));
    geometryField.setAlignmentX(LEFT_ALIGNMENT);
    geometryField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == 'x') ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    geometryField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
	  geometry = " -geometry " + content;
        }
	else
          geometry = "";
      }
    });

    autodoubleBox = new JCheckBox();
    autodoubleBox.setAlignmentX(LEFT_ALIGNMENT);
    autodoubleBox.setText(utils.getString("Options.autodouble"));

    label = new JLabel(utils.getString("Options.arbheight"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(arbheightField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(hl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(heightscaleBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(wl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(widthscaleBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(autoframeskipBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.frameskip_label"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(frameskipTypeBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.maxautoframeskip") + " ");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(frameskipField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(windowBox);
    panel.add(throttleBox);
    panel.add(scanlinesBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.videoeffect") + ":");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(effectBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel("gamma:");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(listScrollPane);
    panel.add(Box.createVerticalStrut(10));
    panel.add(btl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(brightnessBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.geometry"));
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(10));
    panel.add(geometryField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(autodoubleBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                                             utils.getString("Options.general")));
    panel2.add(panel);

    return panel2;
  }

  /**
   * This method creates a panel containing artwork options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createArtworkOptionsPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    artworkBox = new JCheckBox();
    artworkBox.setAlignmentX(LEFT_ALIGNMENT);
    artworkBox.setText(utils.getString("Options.use_artwork"));
    artworkBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          artwork = " -artwork";
        else
          artwork = " -noartwork";
      }
    });

    backdropBox = new JCheckBox();
    backdropBox.setAlignmentX(LEFT_ALIGNMENT);
    backdropBox.setText(utils.getString("Options.use_backdrop_artwork"));
    backdropBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          backdrop = " -backdrop";
        else
          backdrop = " -nobackdrop";
      }
    });

    overlayBox = new JCheckBox();
    overlayBox.setAlignmentX(LEFT_ALIGNMENT);
    overlayBox.setText(utils.getString("Options.use_overlay_artwork"));
    overlayBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          overlay = " -overlay";
        else
          overlay = " -nooverlay";
      }
    });

    bezelBox = new JCheckBox();
    bezelBox.setAlignmentX(LEFT_ALIGNMENT);
    bezelBox.setText(utils.getString("Options.use_bezel_artwork"));
    bezelBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          bezel = " -bezel";
        else
          bezel = " -nobezel";
      }
    });

    cropBox = new JCheckBox();
    cropBox.setAlignmentX(LEFT_ALIGNMENT);
    cropBox.setText(utils.getString("Options.use_crop_artwork"));
    cropBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          crop = " -artcrop";
        else
          crop = " -noartcrop";
      }
    });

    aresolutionField = new JTextField();
    aresolutionField.setAlignmentX(LEFT_ALIGNMENT);
    aresolutionField.setPreferredSize(new Dimension(150, 24));
    aresolutionField.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        char c = e.getKeyChar();
        if (!((Character.isDigit(c) ||
            (c == KeyEvent.VK_BACK_SPACE) ||
            (c == KeyEvent.VK_DELETE)))) {
          getToolkit().beep();
          e.consume();
        }
      }
    });
    aresolutionField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
          try {
            Integer.parseInt(content);
	    artworkresolution = " -artres " + content;
          } catch (NumberFormatException nfe) {
            getToolkit().beep();
            textField.setText("");
            textField.requestFocus();
	    JOptionPane.showMessageDialog(null,
                               utils.getString("Messagebox.error_novalidint"),
                               utils.getString("Messagebox.error_title"),
                               JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    });

    panel.add(artworkBox);
    panel.add(backdropBox);
    panel.add(overlayBox);
    panel.add(bezelBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.artworkresolution") + " ");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(aresolutionField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(cropBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.artwork")));

    panel2.add(panel);

    return panel2;
  }

  /**
   * This method creates a panel containing options to rotate the display.
   *
   * @return <code>JPanel>/code>
   *
   * @since 0.1.3pre3
   */
  public JPanel createDisplayRotationPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    rotateBox = new JCheckBox();
    rotateBox.setAlignmentX(LEFT_ALIGNMENT);
    rotateBox.setText(utils.getString("Options.rotate"));
    rotateBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED) {
          rotate = " -norotate";
        }
        else {
          String OS = System.getProperty("os.name").toLowerCase();
          // System.out.println(OS);
          if (OS.indexOf("windows") > -1) {
            rotate = " -nonorotate";
          }
          else {
            xmame = new Xmame(romeo);

            int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
            int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
            int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

            if (majorNumber == 0 && minorNumber <= 66) {
              if (patchNumber >= 1)
                rotate = " -nonorotate";
              else
                rotate = "";
            }
            else {
              rotate = " -nonorotate";
            }
          }
        }
      }
    });
    
    autororBox = new JCheckBox();
    autororBox.setAlignmentX(LEFT_ALIGNMENT);
    autororBox.setText("autoror");
    autororBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          autoror = " -autoror";
        else
          autoror = " -noautoror";
      }
    });

    autorolBox = new JCheckBox();
    autorolBox.setAlignmentX(LEFT_ALIGNMENT);
    autorolBox.setText("autorol");
    autorolBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          autorol = " -autorol";
        else
          autorol = " -noautorol";
      }
    });

    rorBox = new JCheckBox();
    rorBox.setAlignmentX(LEFT_ALIGNMENT);
    rorBox.setText(utils.getString("Options.rotateright"));
    rorBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED) {
          ror = " -ror";
        }
        else {
          String OS = System.getProperty("os.name").toLowerCase();
          // System.out.println(OS);
          if (OS.indexOf("windows") > -1) {
            ror = " -noror";
          }
          else {
            xmame = new Xmame(romeo);

            int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
            int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
            int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

            if (majorNumber == 0 && minorNumber <= 66) {
              if (patchNumber >= 1)
                ror = " -noror";
              else
                ror = "";
            }
            else {
              ror = " -noror";
            }
          }
        }
      }
    });

    rolBox = new JCheckBox();
    rolBox.setAlignmentX(LEFT_ALIGNMENT);
    rolBox.setText(utils.getString("Options.rotateleft"));
    rolBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED) {
          rol = " -rol";
        }
        else {
          String OS = System.getProperty("os.name").toLowerCase();
          // System.out.println(OS);
          if (OS.indexOf("windows") > -1) {
            rol = " -norol";
          }
          else {
            xmame = new Xmame(romeo);

            int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
            int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
            int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

            if (majorNumber == 0 && minorNumber <= 66) {
              if (patchNumber >= 1)
                rol = " -norol";
              else
                rol = "";
            }
            else {
              rol = " -norol";
            }
          }
        }
      }
    });

    flipxBox = new JCheckBox();
    flipxBox.setAlignmentX(LEFT_ALIGNMENT);
    flipxBox.setText(utils.getString("Options.flipx"));
    flipxBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED) {
          flipx = " -flipx";
        }
        else {
          String OS = System.getProperty("os.name").toLowerCase();
          // System.out.println(OS);
          if (OS.indexOf("windows") > -1) {
            flipx = " -noflipx";
          }
          else {
            xmame = new Xmame(romeo);

            int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
            int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
            int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

            if (majorNumber == 0 && minorNumber <= 66) {
              if (patchNumber >= 1)
                flipx = " -noflipx";
              else
                flipx = "";
            }
            else {
              flipx = " -noflipx";
            }
          }
        }
      }
    });

    flipyBox = new JCheckBox();
    flipyBox.setAlignmentX(LEFT_ALIGNMENT);
    flipyBox.setText(utils.getString("Options.flipy"));
    flipyBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED) {
          flipy = " -flipy";
        }
        else {
          String OS = System.getProperty("os.name").toLowerCase();
          // System.out.println(OS);
          if (OS.indexOf("windows") > -1) {
            flipy = " -noflipy";
          }
          else {
            xmame = new Xmame(romeo);

            int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
            int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
            int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

            if (majorNumber == 0 && minorNumber <= 66) {
              if (patchNumber >= 1)
                flipy = " -noflipy";
              else
                flipy = "";
            }
            else {
              flipy = " -noflipy";
            }
          }
        }
      }
    });

    panel.add(rotateBox);
    panel.add(autororBox);
    panel.add(autorolBox);
    panel.add(rorBox);
    panel.add(rolBox);
    panel.add(flipxBox);
    panel.add(flipyBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.display")));
    panel2.add(panel);

    return panel2;
  }
  
  /**
   * This method returns a panel containing vector games options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createVectorGamesOptionsPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    String OS = System.getProperty("os.name").toLowerCase();
    if (OS.indexOf("windows") == -1) {
      vectorresField = new JTextField();
      vectorresField.setAlignmentX(LEFT_ALIGNMENT);
      vectorresField.setPreferredSize(new Dimension(150, 24));
      vectorresField.addFocusListener(new FocusAdapter() {
        public void focusLost(FocusEvent e) {
          JTextField textField = (JTextField)e.getSource();
          String content = textField.getText();
          if (content.length() != 0) {
	    vectorres = " -vectorres " + content;
          }
	  else
            vectorres = "";
        }
      });
    }

    JLabel bl = new JLabel(utils.getString("Options.beam") + " 1.0");

    beamBox = new JSlider(1000, 16000, 1000);
    beamBox.setAlignmentX(LEFT_ALIGNMENT);
    beamBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    //beamBox.setPaintTicks(true);
    //beamBox.setMajorTickSpacing(1);
    sListener = new SliderListener(bl);
    beamBox.addChangeListener(sListener);

    JLabel fl = new JLabel(utils.getString("Options.flicker") + " 0.0");

    flickerBox = new JSlider(0, 100000, 0);
    flickerBox.setAlignmentX(LEFT_ALIGNMENT);
    flickerBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    //flickerBox.setPaintTicks(true);
    //flickerBox.setMajorTickSpacing(1);
    sListener = new SliderListener(fl);
    flickerBox.addChangeListener(sListener);
    
    JLabel il = new JLabel(utils.getString("Options.intensity") + " 1.5");
    il.setAlignmentX(LEFT_ALIGNMENT);

    intensityBox = new JSlider(5, 30, 15);
    intensityBox.setAlignmentX(LEFT_ALIGNMENT);
    intensityBox.putClientProperty("JSlider.isFilled", Boolean.TRUE );
    //intensityBox.setPaintTicks(true);
    //intensityBox.setMajorTickSpacing(1);
    sListener = new SliderListener(il);
    intensityBox.addChangeListener(sListener);
    
    antialiasBox = new JCheckBox();
    antialiasBox.setAlignmentX(LEFT_ALIGNMENT);
    antialiasBox.setText(utils.getString("Options.antialias"));
    antialiasBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          antialias = " -antialias";
        else
          antialias = " -noantialias";
      }
    });

    tlucencyBox = new JCheckBox();
    tlucencyBox.setAlignmentX(LEFT_ALIGNMENT);
    tlucencyBox.setText(utils.getString("Options.translucency"));
    tlucencyBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          translucency = " -translucency";
        else
          translucency = " -notranslucency";
      }
    });

    if (OS.indexOf("windows") == -1) {
      label = new JLabel(utils.getString("Options.vectorres") + " ");
      label.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(label);
      panel.add(Box.createVerticalStrut(5));
      panel.add(vectorresField);
      panel.add(Box.createVerticalStrut(10));
    }
    panel.add(bl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(beamBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(fl);
    panel.add(Box.createVerticalStrut(5));
    panel.add(flickerBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(il);
    panel.add(Box.createVerticalStrut(5));
    panel.add(intensityBox);
    panel.add(Box.createVerticalStrut(10));
    panel.add(antialiasBox);
    panel.add(tlucencyBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.vector")));
    panel2.add(panel);

    return panel2;
  }

  /**
   * This method returns a panel containing Windows input options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createWindowsInputPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    mouseBox = new JCheckBox();
    mouseBox.setAlignmentX(LEFT_ALIGNMENT);
    mouseBox.setText("mouse");
    mouseBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          mouse = " -mouse";
        else
          mouse = " -nomouse";
      }
    });
    
    joystickBox = new JCheckBox();
    joystickBox.setAlignmentX(LEFT_ALIGNMENT);
    joystickBox.setText("joystick");
    joystickBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          joystick = " -joystick";
        else
          joystick = " -nojoystick";
      }
    });
    
    steadykeyBox = new JCheckBox();
    steadykeyBox.setAlignmentX(LEFT_ALIGNMENT);
    steadykeyBox.setText("steady key");
    steadykeyBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          steadykey = " -steadykey";
        else
          steadykey = " -nosteadykey";
      }
    });
    
    keyboardledsBox = new JCheckBox();
    keyboardledsBox.setAlignmentX(LEFT_ALIGNMENT);
    keyboardledsBox.setText("keyboard leds");
    keyboardledsBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          keyboardleds = " -keyboard_leds";
        else
          keyboardleds = " -nokeyboard_leds";
      }
    });
    
    label = new JLabel("Enables support for special controllers:");
    label.setAlignmentX(LEFT_ALIGNMENT);

    String[] ctrlrs = {" hotrod", " hotrodse", " slikstik", " xarcade"};
    
    ctrlrBox = new JComboBox(ctrlrs);
    ctrlrBox.setAlignmentX(LEFT_ALIGNMENT);
    ctrlrBox.setPreferredSize(new Dimension(200, 24));
    ctrlrBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();

	  ctrlr = " -ctrlr " + cb.getSelectedItem().toString().trim();
      }
    });

    panel.add(mouseBox);
    panel.add(joystickBox);
    panel.add(steadykeyBox);
    panel.add(keyboardledsBox);
    panel.add(label);
    panel.add(ctrlrBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.input")));

    panel2.add(panel);

    return panel2;
  }
  
  /**
   * This method returns a panel containing xmame input options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createLinuxInputPanel() {
    panel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    String[] joytypes = {" 0 No joystick",
                         " 1 i386 style joystick driver",
                         " 2 Fm Town Pad support",
                         " 3 X11 input extension joystick",
                         " 4 new i386 linux 1.x.x joystick driver",
                         " 5 NetBSD USB joystick driver",
                         " 6 PS2-Linux native pad",
                         " 7 SDL joystick driver"};

    joytypeBox = new JComboBox(joytypes);
    joytypeBox.setAlignmentX(LEFT_ALIGNMENT);
    joytypeBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();

	joytype = " -joytype " + cb.getSelectedIndex();
      }
    });

    joydevnameField = new JTextField();
    joydevnameField.setAlignmentX(LEFT_ALIGNMENT);
    joydevnameField.setPreferredSize(new Dimension(150, 24));
    joydevnameField.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0)
          joydevname = " -joydevname " + content;
      }
    });
    
    mouseBox = new JCheckBox();
    mouseBox.setAlignmentX(LEFT_ALIGNMENT);
    mouseBox.setText("mouse");
    mouseBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          mouse = " -mouse";
        else
          mouse = " -nomouse";
      }
    });

    analogstickBox = new JCheckBox();
    analogstickBox.setAlignmentX(LEFT_ALIGNMENT);
    analogstickBox.setText(utils.getString("Options.analogstick"));
    analogstickBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          analogstick = " -analogstick";
        else
          analogstick = " -noanalogstick";
      }
    });

    hotrodBox = new JCheckBox();
    hotrodBox.setAlignmentX(LEFT_ALIGNMENT);
    hotrodBox.setText(utils.getString("Options.hotrod"));
    hotrodBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          hotrod = " -hotrod";
        else
          hotrod = " -nohotrod";
      }
    });

    hotrodseBox = new JCheckBox();
    hotrodseBox.setAlignmentX(LEFT_ALIGNMENT);
    hotrodseBox.setText(utils.getString("Options.hotrodse"));
    hotrodseBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          hotrodse = " -hotrodse";
        else
          hotrodse = " -nohotrodse";
      }
    });

    usbpspadBox = new JCheckBox();
    usbpspadBox.setAlignmentX(LEFT_ALIGNMENT);
    usbpspadBox.setText("USB PS Game Pads");
    usbpspadBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          usbpspad = " -usbpspad";
        else
          usbpspad = " -nousbpspad";
      }
    });

    rapidfireBox = new JCheckBox();
    rapidfireBox.setAlignmentX(LEFT_ALIGNMENT);
    rapidfireBox.setText(utils.getString("Options.rapidfire"));
    rapidfireBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
          rapidfire = " -rapidfire";
        else
          rapidfire = " -norapidfire";
      }
    });

    label = new JLabel(utils.getString("Options.joytype") + " ");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(joytypeBox);
    panel.add(Box.createVerticalStrut(10));
    label = new JLabel(utils.getString("Options.joydevname") + " ");
    label.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(label);
    panel.add(Box.createVerticalStrut(5));
    panel.add(joydevnameField);
    panel.add(Box.createVerticalStrut(10));
    panel.add(mouseBox);
    panel.add(analogstickBox);
    panel.add(hotrodBox);
    panel.add(hotrodseBox);
    panel.add(usbpspadBox);
    panel.add(rapidfireBox);

    panel2 = new JPanel();
    panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
    panel2.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Options.input")));
    panel2.add(panel);

    return panel2;
  }

  class SliderListener implements ChangeListener {
    JLabel l;

    public SliderListener(JLabel label) {
      l = label;
    }

    public void stateChanged(ChangeEvent e) {
      String s = new String();
      JSlider s1 = (JSlider)e.getSource();
      if (s1 == volumeBox) {
        volume = " -volume " + s1.getValue();
        l.setText(utils.getString("Options.volume") + " " +
                  s1.getValue() + "db");
      }
      else if (s1 == beamBox) {
        float value = (float)(s1.getValue() / 1000);
        beam = " -beam " + value;
        l.setText(utils.getString("Options.beam") + " " +
                  value);
      }
      else if (s1 == flickerBox) {
        float value = (float)(s1.getValue() / 1000);
        flicker = " -flicker " + value;
        l.setText(utils.getString("Options.flicker") + " " +
                  value);
      }
      else if (s1 == intensityBox) {
        if (s1.getValue() < 10)
          s = "0." + s1.getValue();
        else if (s1.getValue() == 10)
          s = "1.0";
        else if (s1.getValue() > 10 && s1.getValue() < 20) {
          String parse = "1." + s1.getValue();
	  s = parse.substring(0, 2) + parse.substring(3);
        }
        else if (s1.getValue() == 20)
          s = "2.0";
	else if (s1.getValue() > 20 & s1.getValue() < 30) {
	  String parse = "2." + s1.getValue();
	  //System.out.println(parse);
          s = parse.substring(0, 2) + parse.substring(3);
	}
	else if (s1.getValue() == 30)
	  s = "3.0";

        intensity = " -intensity " + s;
        l.setText(utils.getString("Options.intensity") + " " + s);
      }
      else if (s1 == brightnessBox) {
        xmame = new Xmame(romeo);

        int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
        int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
        int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

        if (majorNumber == 0 && minorNumber <= 66) {
          if (patchNumber >= 1) {
            if (s1.getValue() < 10)
              s = "0." + s1.getValue();
            else if (s1.getValue() == 10)
              s = "1.0";
            else if (s1.getValue() > 10 && s1.getValue() < 20) {
              String parse = "1." + s1.getValue();
	      s = parse.substring(0, 2) + parse.substring(3);
            }
            else if (s1.getValue() == 20)
              s = "2.0";

            brightness = " -brightness " + s;
            l.setText(utils.getString("Options.brightness") + ": " + s);
          }
          else {
            brightness = " -brightness " + s1.getValue();
            l.setText(utils.getString("Options.brightness") + ": " + s1.getValue() + "%");
          }
        }
        else {
          if (s1.getValue() < 10)
            s = "0." + s1.getValue();
          else if (s1.getValue() == 10)
            s = "1.0";
          else if (s1.getValue() > 10 && s1.getValue() < 20) {
            String parse = "1." + s1.getValue();
	    s = parse.substring(0, 2) + parse.substring(3);
          }
          else if (s1.getValue() == 20)
            s = "2.0";

          brightness = " -brightness " + s;
          l.setText(utils.getString("Options.brightness") + ": " + s);
        }
      }
      else if (s1 == heightscaleBox) {
        heightscale = " -heightscale " + s1.getValue();
        l.setText(utils.getString("Options.heightscale") + " " + s1.getValue());
      }

      else if (s1 == widthscaleBox) {
        widthscale = " -widthscale " + s1.getValue();
        l.setText(utils.getString("Options.widthscale") + " " + s1.getValue());
      }
    }
  }

  public void setOptionsComponentsLocked() {
    if (defaultBox.isSelected())
      defaultBox.setSelected(false);
    else
      defaultBox.setSelected(true);

    File gameConfig = new File(System.getProperty("user.home") +
                                     File.separator + ".romeo4xmame" +
                                     File.separator + "Games" + File.separator +
                                     romeo.games.gameName + "rc");

    if (gameConfig.exists())
      defaultBox.setSelected(false);
    else
      defaultBox.setSelected(true);
  }
  
  /**
   * PlayGame Action
   */
  class PlayGameAction extends AbstractAction {
    Options options;
    protected PlayGameAction(Options options) {
      super("PlayGame");
      this.options = options;
    }

    public void actionPerformed(ActionEvent e) {
       runMame();
    }
  }
  
  /**
   * Run Mame and load a selected game.
   *
   * @see #getWindowsOptions()
   * @see #getLinuxOptions()
   * @see #getOtherOptions()
   * @see com.miami.romeo.xmame.Xmame#runMame(String, String)
   */
  public void runMame() {
    xmame = new Xmame(romeo);
    config = new Config(new File(System.getProperty("user.home") +
                                 File.separator + ".romeo4xmame" +
				 File.separator + "Romeo.ini"));

    gameName = romeo.games.gameName;
    mamePath = romeo.games.getXmamePath();
    romPath = " -rompath " + romeo.games.getGamePath(romeo.games.getRomDirs(),
              gameName);
	      
    int n = config.getInt(romeo.games.getNameOfList(mamePath) + ".total_played");
    if (n == -1)
      n = 0;
    int MAX = n + 1;
    config.add(romeo.games.getNameOfList(mamePath) + ".total_played", MAX);
    config.save();

    romeo.games.setNumberOfPlayedMatches(gameName, MAX);

    if (!defaultBox.isSelected()) {
      String OS = System.getProperty("os.name").toLowerCase();
      // System.out.println(OS);
      if (OS.indexOf("windows") > -1) {
        gameOptions = " " + gameName + getWindowsOptions() + getOtherOptions() +
	              romPath;
      }
      else {
        gameOptions = " " + gameName + getLinuxOptions() + getOtherOptions() +
	              romPath;
      }

      romeo.games.appendMessage("Info", "Running " + romeo.statusField.getText() +
                                " with options:\n");
      romeo.games.appendMessage("Run", mamePath + " " + gameName + " " +
                                gameOptions.substring(gameOptions.indexOf('-')) + "\n\n");
    }
    else {
      gameOptions = " " + gameName + romPath;
      romeo.games.appendMessage("Info", "Running " + romeo.statusField.getText() +
                                " with default options.\n\n");
    }
    
    //System.out.println(gameOptions);

    iconifyWindows = config.getBoolean("Iconify_before_playing");

    Thread thread = new Thread() {
      public void run() {
        try {
          if (iconifyWindows) {
            Frame[] frame = romeo.getFrame().getFrames();
            for (int i = 0; i < frame.length; i++) {
              if (frame[i] != null)
                frame[i].setState(Frame.ICONIFIED);
            }
          }

          xmame.runMame(mamePath, gameOptions);
        }
        catch(IOException ioe) {
          System.err.println(ioe.getMessage());
        }
      }
    };

    thread.start();

    try {
      thread.join();

      if (iconifyWindows) {
        Frame[] frame = romeo.getFrame().getFrames();

        for (int i = 0; i < frame.length; i++) {
          if (frame[i] != null)
            frame[i].setState(Frame.NORMAL);
        }
      }
    }
    catch(InterruptedException ie) {
      System.out.println(ie.getMessage());
    }
  }

  public void enableAll(boolean enable) {
    if (enable) {
      resetOptions();
      enableComponents(enable);
      saveOptions.setEnabled(!enable);
    }
    else {
      resetOptions();
      enableComponents(false);
      saveOptions.setEnabled(true);

      File gameConfig = new File(System.getProperty("user.home") +
                                 File.separator + ".romeo4xmame" +
                                 File.separator + "Games" + File.separator +
                                 romeo.games.gameName + "rc");

      if (gameConfig.exists())
        loadYourOptions();
      else
        resetOptions();
    }
  }
  
  /**
   * This method enables/disables all components.
   *
   * @param  enable If <code>true</code> enables all components,
   *                else disables them.
   *
   * @since  0.1.3pre3
   */
  public void enableComponents(boolean enable) {
    romeo.setLocked(enable, centerPanel);
  }

  /**
   * This method resets options to their original value.
   *
   * @see    #resetWindowsOptions()
   * @see    #resetLinuxOptions()
   *
   * @since  0.1.3pre3
   */
  public void resetOptions() {
    String OS = System.getProperty("os.name").toLowerCase();
    // System.out.println(OS);
    if (OS.indexOf("windows") > -1) {
      resetWindowsOptions();
    }
    else {
      resetLinuxOptions();
    }
  }
  
  /**
   * This method resets Windows options to their original value.
   *
   * @since  0.1.3pre3
   */
  public void resetWindowsOptions() {
    boolean[] bvalues = {false,
                         true,
                         true,
			 true,
                         true,
			 false,
			 true,
			 false,
			 true,
			 true,
			 true,
			 true,
			 false,
			 true,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 true,
			 true,
			 true};

    JCheckBox[] bcomp = {cheatBox, soundBox, samplesBox, resamplefilterBox,
                         autoframeskipBox, windowBox, throttleBox,
			 scanlinesBox, artworkBox, backdropBox, overlayBox,
			 bezelBox, cropBox,
			 rotateBox, autororBox, autorolBox,rorBox,
			 rolBox, flipxBox, flipyBox, mouseBox, joystickBox,
			 steadykeyBox, keyboardledsBox, antialiasBox,
			 tlucencyBox};

    for (int i = 0; i < bvalues.length; i++) {
      bcomp[i].setSelected(bvalues[i]);
    }

    int[] ivalues = {2,
                     0,
		     0};

    JComboBox[] icomp = {samplefreqBox,
                         effectBox,
		         ctrlrBox};
			  
    for (int i = 0; i < ivalues.length; i++) {
      icomp[i].setSelectedIndex(ivalues[i]);
    }
    
    gammaBox.setValue("1.0");

    int[] svalues = {0,
                     10,
		     1000,
		     0,
		     15};

    JSlider[] scomp = {volumeBox, brightnessBox, beamBox,
                       flickerBox, intensityBox};

    for (int i = 0; i < svalues.length; i++) {
      scomp[i].setValue(svalues[i]);
    }
    
    String[] tvalues = {"0",
                        "0"};

    JTextField[] tcomp = {frameskipField, aresolutionField};

    for (int i = 0; i < tvalues.length; i++) {
      tcomp[i].setText(tvalues[i]);
    }
  }
  
  /**
   * This method resets XMame options to their original value.
   *
   * @since  0.1.3pre3
   */
  public void resetLinuxOptions() {
    boolean[] bvalues = {false,
                         true,
                         true,
			 true,
			 false,
                         true,
			 false,
			 false,
			 true,
			 true,
			 true,
			 true,
			 true,
			 true,
			 false,
			 true,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 false,
			 true,
			 true};

    JCheckBox[] bcomp = {cheatBox, timerBox, soundBox,
                         samplesBox, fakesoundBox,
                         autoframeskipBox, autodoubleBox,
			 windowBox, throttleBox,
			 scanlinesBox, artworkBox,
			 backdropBox, overlayBox,
			 bezelBox, cropBox,
			 rotateBox, autororBox,
			 autorolBox,rorBox,
			 rolBox, flipxBox,
			 flipyBox, mouseBox,
			 analogstickBox, hotrodBox,
			 hotrodseBox, usbpspadBox,
			 rapidfireBox, antialiasBox,
			 tlucencyBox};

    for (int i = 0; i < bvalues.length; i++) {
      bcomp[i].setSelected(bvalues[i]);
    }

    int[] ivalues = {0,
                     0,
		     2,
		     1,
                     0,
		     0};

    JComboBox[] icomp = {dspBox, mixerBox, samplefreqBox, frameskipTypeBox,
                         effectBox, joytypeBox};

    for (int i = 0; i < ivalues.length; i++) {
      icomp[i].setSelectedIndex(ivalues[i]);
    }
    
    gammaBox.setValue("1.0");

    int[] svalues = {0,
		     1000,
		     0,
		     15,
                     1,
                     1};


    JSlider[] scomp = {volumeBox, beamBox,
                       flickerBox, intensityBox,
                       heightscaleBox, widthscaleBox};

    for (int i = 0; i < svalues.length; i++) {
      scomp[i].setValue(svalues[i]);
    }

    xmame = new Xmame(romeo);

    int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
    int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());
    int patchNumber = xmame.getXmamePatchLevel(romeo.games.getXmamePath());

    if (majorNumber == 0 && minorNumber <= 66) {
      if (patchNumber >= 1) {
        if (brightnessBox.getMaximum() == 100) {
          brightnessBox.setMinimum(5);
          brightnessBox.setMaximum(20);
        }
        brightnessBox.setValue(10);
      }
      else {
        if (brightnessBox.getMaximum() == 20) {
          brightnessBox.setMinimum(0);
          brightnessBox.setMaximum(100);
        }
        brightnessBox.setValue(50);
      }
    }
    else {
      if (brightnessBox.getMaximum() == 100) {
        brightnessBox.setMinimum(5);
        brightnessBox.setMaximum(20);
      }
      brightnessBox.setValue(10);
    }

    String[] tvalues = {"8",
                        "3.000",
                        "0",
			"",
			"",
                        "0",
			"",
			"",
                        ""};

    JTextField[] tcomp = {frameskipField,
                          bufsizeField, arbheightField,
                          audiodeviceField, mixerdeviceField,
			  aresolutionField, geometryField,
                          joydevnameField, vectorresField};

    for (int i = 0; i < tvalues.length; i++) {
      tcomp[i].setText(tvalues[i]);
    }
  }

  /**
   * This method loads user options
   *
   * @see #loadWindowsOptions()
   * @see #loadLinuxOptions()
   */
  public void loadYourOptions () {
    String OS = System.getProperty("os.name").toLowerCase();
    // System.out.println(OS);
    if (OS.indexOf("windows") > -1) {
      loadWindowsOptions();
    }
    else {
      loadLinuxOptions();
    }
  }
  
  /**
   * This method loads Windows options.
   *
   * @since  0.1.3pre3
   */
  public void loadWindowsOptions() {
    File gameConfig = new File(System.getProperty("user.home") + File.separator +
                               ".romeo4xmame" + File.separator +
                               "Games" + File.separator +
                               romeo.games.gameName + "rc");

    Config config = new Config(gameConfig);

    boolean[] bvalues = {config.getBoolean("cheat"),
                         config.getBoolean("sound"),
                         config.getBoolean("samples"),
			 config.getBoolean("resamplefilter"),
                         config.getBoolean("autoframeskip"),
			 config.getBoolean("window"),
			 config.getBoolean("throttle"),
			 config.getBoolean("scanlines"),
			 config.getBoolean("artwork"),
			 config.getBoolean("backdrop"),
			 config.getBoolean("overlay"),
			 config.getBoolean("bezel"),
			 config.getBoolean("crop"),
			 config.getBoolean("rotate"),
			 config.getBoolean("autoror"),
			 config.getBoolean("autorol"),
			 config.getBoolean("ror"),
			 config.getBoolean("rol"),
			 config.getBoolean("flipx"),
			 config.getBoolean("flipy"),
			 config.getBoolean("mouse"),
			 config.getBoolean("joystick"),
			 config.getBoolean("steadykey"),
			 config.getBoolean("keyboardleds"),
			 config.getBoolean("antialias"),
			 config.getBoolean("translucency")};

    JCheckBox[] bcomp = {cheatBox, soundBox, samplesBox, resamplefilterBox,
                         autoframeskipBox, windowBox, throttleBox,
			 scanlinesBox, artworkBox, backdropBox, overlayBox,
			 bezelBox, cropBox,
			 rotateBox, autororBox, autorolBox,rorBox,
			 rolBox, flipxBox, flipyBox, mouseBox, joystickBox,
			 steadykeyBox, keyboardledsBox, antialiasBox,
			 tlucencyBox};

    for (int i = 0; i < bvalues.length; i++) {
      bcomp[i].setSelected(bvalues[i]);
    }

    int[] ivalues = {config.getInt("samplefreq"),
                     config.getInt("effect"),
		     config.getInt("ctrlr")};

    JComboBox[] icomp = {samplefreqBox,
                         effectBox,
		         ctrlrBox};

    for (int i = 0; i < ivalues.length; i++) {
      icomp[i].setSelectedIndex(ivalues[i]);
    }

    gammaBox.setValue(config.get("gamma"));

    int[] svalues = {config.getInt("volume"),
                     config.getInt("brightness"),
		     config.getInt("beam"),
		     config.getInt("flicker"),
		     config.getInt("intensity")};

    JSlider[] scomp = {volumeBox, brightnessBox, beamBox,
                       flickerBox, intensityBox};

    for (int i = 0; i < svalues.length; i++) {
      scomp[i].setValue(svalues[i]);
    }

    String[] tvalues = {config.get("frameskip"),
                        config.get("artworkresolution")};

    JTextField[] tcomp = {frameskipField, aresolutionField};

    for (int i = 0; i < tvalues.length; i++) {
      tcomp[i].setText(tvalues[i]);
    }
  }

  /**
   * This method loads XMame options.
   *
   * @since  0.1.3pre3
   */
  public void loadLinuxOptions() {
    File gameConfig = new File(System.getProperty("user.home") + File.separator +
                               ".romeo4xmame" + File.separator +
                               "Games" + File.separator +
                               romeo.games.gameName + "rc");

    Config config = new Config(gameConfig);

    boolean[] bvalues = {config.getBoolean("cheat"),
                         config.getBoolean("timer"),
                         config.getBoolean("sound"),
			 config.getBoolean("samples"),
			 config.getBoolean("fakesound"),
                         config.getBoolean("autoframeskip"),
			 config.getBoolean("autodouble"),
			 config.getBoolean("window"),
			 config.getBoolean("throttle"),
			 config.getBoolean("scanlines"),
			 config.getBoolean("artwork"),
			 config.getBoolean("backdrop"),
			 config.getBoolean("overlay"),
			 config.getBoolean("bezel"),
			 config.getBoolean("crop"),
			 config.getBoolean("rotate"),
			 config.getBoolean("autoror"),
			 config.getBoolean("autorol"),
			 config.getBoolean("ror"),
			 config.getBoolean("rol"),
			 config.getBoolean("flipx"),
			 config.getBoolean("flipy"),
			 config.getBoolean("mouse"),
			 config.getBoolean("analogstick"),
			 config.getBoolean("hotrod"),
			 config.getBoolean("hotrodse"),
			 config.getBoolean("usbpspad"),
			 config.getBoolean("rapidfire"),
			 config.getBoolean("antialias"),
			 config.getBoolean("translucency")};

    JCheckBox[] bcomp = {cheatBox, timerBox, soundBox,
                         samplesBox, fakesoundBox,
                         autoframeskipBox, autodoubleBox,
			 windowBox, throttleBox,
			 scanlinesBox, artworkBox,
			 backdropBox, overlayBox,
			 bezelBox, cropBox,
			 rotateBox, autororBox,
			 autorolBox,rorBox,
			 rolBox, flipxBox,
			 flipyBox, mouseBox,
			 analogstickBox, hotrodBox,
			 hotrodseBox, usbpspadBox,
			 rapidfireBox, antialiasBox,
			 tlucencyBox};

    for (int i = 0; i < bvalues.length; i++) {
      bcomp[i].setSelected(bvalues[i]);
    }

    int[] ivalues = {config.getInt("dsp"),
                     config.getInt("mixer"),
		     config.getInt("samplefreq"),
		     config.getInt("frameskipper"),
                     config.getInt("effect"),
		     config.getInt("joytype")};

    JComboBox[] icomp = {dspBox, mixerBox, samplefreqBox, frameskipTypeBox,
                         effectBox, joytypeBox};

    for (int i = 0; i < ivalues.length; i++) {
      icomp[i].setSelectedIndex(ivalues[i]);
    }
    
    gammaBox.setValue(config.get("gamma"));

    int[] svalues = {config.getInt("volume"),
		     config.getInt("beam"),
		     config.getInt("flicker"), 
		     config.getInt("intensity"),
                     config.getInt("heightscale"),
                     config.getInt("widthscale")};

    JSlider[] scomp = {volumeBox, beamBox,
                       flickerBox, intensityBox,
                       heightscaleBox, widthscaleBox};

    for (int i = 0; i < svalues.length; i++) {
      scomp[i].setValue(svalues[i]);
    }

    int b = config.getInt("brightness");

    xmame = new Xmame(romeo);

    int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
    int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());

    if (majorNumber == 0 && minorNumber <= 66) {
      brightnessBox.setValue(b);
    }
    else {
      if (b < 5 || b > 20)
        brightnessBox.setValue(10);
      else
        brightnessBox.setValue(b);
    }

    String[] tvalues = {config.get("arbheight"),
                        config.get("frameskip"),
                        config.get("bufsize"),
			config.get("audiodevice"),
			config.get("mixerdevice"),
                        config.get("artworkresolution"), 
			config.get("geometry"),
			config.get("joydevname"),
                        config.get("vectorres")};

    JTextField[] tcomp = {arbheightField, frameskipField, bufsizeField,
                          audiodeviceField, mixerdeviceField,
			  aresolutionField, geometryField,
                          joydevnameField, vectorresField};

    for (int i = 0; i < tvalues.length; i++) {
      tcomp[i].setText(tvalues[i]);
    }
  }

  /**
   * SaveYourOptions Action
   *
   * @see #save()
   */
  class SaveYourOptionsAction extends AbstractAction {
    Options options;
    protected SaveYourOptionsAction(Options options) {
      super("SaveYourOptions");
      this.options = options;
    }

    public void actionPerformed(ActionEvent e) {
      save();
    }
  }

  /**
   * This method saves user options.
   *
   * @see   #saveWindowsOptions()
   * @see   #saveLinuxOptions()
   *
   * @since 0.1.3pre3
   */
  public void save() {
    String OS = System.getProperty("os.name").toLowerCase();
    // System.out.println(OS);
    if (OS.indexOf("windows") > -1) {
      saveWindowsOptions();
    }
    else {
      saveLinuxOptions();
    }
  }

  /**
   * This method saves Windows options.
   *
   * @since  0.1.3pre3
   */
  public void saveWindowsOptions() {
    File gameConfig = new File(System.getProperty("user.home") + File.separator +
                               ".romeo4xmame" + File.separator +
                               "Games" + File.separator +
                               romeo.games.gameName + "rc");

    Config config = new Config(gameConfig);

    String[] bparams = {"cheat", "sound", "samples", "resamplefilter",
                        "autoframeskip", "window", "throttle",
			"scanlines", "artwork", "backdrop", "overlay",
			"bezel", "crop", "rotate", "autoror", "autorol",
			"ror", "rol", "flipx", "flipy", "mouse", "joystick",
			"steadykey", "keyboardleds", "antialias",
			"translucency"};

    boolean[] bvalues = {cheatBox.isSelected(), soundBox.isSelected(), samplesBox.isSelected(),
                         resamplefilterBox.isSelected(), autoframeskipBox.isSelected(),
			 windowBox.isSelected(), throttleBox.isSelected(),
			 scanlinesBox.isSelected(), artworkBox.isSelected(),
			 backdropBox.isSelected(), overlayBox.isSelected(),
			 bezelBox.isSelected(), cropBox.isSelected(),
			 rotateBox.isSelected(), autororBox.isSelected(),
			 autorolBox.isSelected(),rorBox.isSelected(),
			 rolBox.isSelected(), flipxBox.isSelected(),
			 flipyBox.isSelected(), mouseBox.isSelected(),
			 joystickBox.isSelected(), steadykeyBox.isSelected(),
			 keyboardledsBox.isSelected(), antialiasBox.isSelected(),
			 tlucencyBox.isSelected()};

    for (int i = 0; i < bparams.length; i++) {
      config.add(bparams[i], bvalues[i]);
    }

    String[] iparams = {"samplefreq", "effect", "ctrlr"};

    int[] ivalues = {samplefreqBox.getSelectedIndex(),
                     effectBox.getSelectedIndex(),
		     ctrlrBox.getSelectedIndex()};
		     
    for (int i = 0; i < iparams.length; i++) {
      config.add(iparams[i], ivalues[i]);
    }
    
    String[] sparams = {"volume", "brightness", "beam", "flicker", "intensity"};

    int[] svalues = {volumeBox.getValue(), brightnessBox.getValue(), beamBox.getValue(),
                     flickerBox.getValue(), intensityBox.getValue()};

    for (int i = 0; i < sparams.length; i++) {
      config.add(sparams[i], svalues[i]);
    }

    String[] tparams = {"frameskip", "gamma", "artworkresolution"};

    String[] tvalues = {frameskipField.getText(),
                        gammaBox.getValue().toString(), aresolutionField.getText()};

    for (int i = 0; i < tparams.length; i++) {
      config.add(tparams[i], tvalues[i]);
    }

    config.save();
  }

  /**
   * This method saves XMame options.
   *
   * @since  0.1.3pre3
   */
  public void saveLinuxOptions() {
    File gameConfig = new File(System.getProperty("user.home") + File.separator +
                               ".romeo4xmame" + File.separator +
                               "Games" + File.separator +
                               romeo.games.gameName + "rc");

    Config config = new Config(gameConfig);

    String[] bparams = {"cheat", "timer", "sound", "samples", "fakesound",
                        "autoframeskip", "autodouble", "window", "throttle",
			"scanlines", "artwork", "backdrop", "overlay",
			"bezel", "crop", "rotate", "autoror", "autorol",
			"ror", "rol", "flipx", "flipy", "mouse", "analogstick",
			"hotrod", "hotrodse", "usbpspad", "rapidfire", "antialias",
			"translucency"};

    boolean[] bvalues = {cheatBox.isSelected(), timerBox.isSelected(), soundBox.isSelected(),
                         samplesBox.isSelected(), fakesoundBox.isSelected(),
                         autoframeskipBox.isSelected(), autodoubleBox.isSelected(),
			 windowBox.isSelected(), throttleBox.isSelected(),
			 scanlinesBox.isSelected(), artworkBox.isSelected(),
			 backdropBox.isSelected(), overlayBox.isSelected(),
			 bezelBox.isSelected(), cropBox.isSelected(),
			 rotateBox.isSelected(), autororBox.isSelected(),
			 autorolBox.isSelected(),rorBox.isSelected(),
			 rolBox.isSelected(), flipxBox.isSelected(),
			 flipyBox.isSelected(), mouseBox.isSelected(),
			 analogstickBox.isSelected(), hotrodBox.isSelected(),
			 hotrodseBox.isSelected(), usbpspadBox.isSelected(),
			 rapidfireBox.isSelected(), antialiasBox.isSelected(),
			 tlucencyBox.isSelected()};

    for (int i = 0; i < bparams.length; i++) {
      config.add(bparams[i], bvalues[i]);
    }

    String[] iparams = {"dsp", "mixer", "samplefreq", "frameskipper",
                        "effect", "joytype"};

    int[] ivalues = {dspBox.getSelectedIndex(),
                     mixerBox.getSelectedIndex(),
                     samplefreqBox.getSelectedIndex(),
		     frameskipTypeBox.getSelectedIndex(),
                     effectBox.getSelectedIndex(),
		     joytypeBox.getSelectedIndex()};

    for (int i = 0; i < iparams.length; i++) {
      config.add(iparams[i], ivalues[i]);
    }

    String[] sparams = {"volume", "brightness", "beam", "flicker", "intensity",
                        "heightscale", "widthscale"};

    int[] svalues = {volumeBox.getValue(), brightnessBox.getValue(), beamBox.getValue(),
                     flickerBox.getValue(), intensityBox.getValue(), heightscaleBox.getValue(),
                     widthscaleBox.getValue()};

    for (int i = 0; i < sparams.length; i++) {
      config.add(sparams[i], svalues[i]);
    }
    
    String[] tparams = {"arbheight", "frameskip", "gamma", "bufsize", "audiodevice", "mixerdevice",
                        "artworkresolution", "geometry", "joydevname", "vectorres"};

    String[] tvalues = {arbheightField.getText(), frameskipField.getText(), gammaBox.getValue().toString(), bufsizeField.getText(),
                        audiodeviceField.getText(), mixerdeviceField.getText(),
			aresolutionField.getText(), geometryField.getText(),
                        joydevnameField.getText(), vectorresField.getText()};

    for (int i = 0; i < tparams.length; i++) {
      config.add(tparams[i], tvalues[i]);
    }
    
    config.save();
  }
  
  /**
   * This method returns Windows options.
   *
   * @return String Windows options
   *
   * @since  0.1.3pre3
   */
  public String getWindowsOptions() {
    String options = sound + samples + samplefreq + volume + resamplefilter +
		     autoframeskip + frameskip + window + throttle + scanlines + 
		     effect + gamma + brightness + artwork + backdrop + overlay +
		     bezel + artworkresolution + crop + rotate + autoror +
		     autorol + ror + rol + flipx + flipy + joystick + steadykey +
		     keyboardleds + mouse + ctrlr + beam + flicker + intensity +
		     antialias + translucency + cheat;

    return options;
  }
  
  /**
   * This method returns XMame options.
   *
   * @return String XMame options
   *
   * @since  0.1.3pre3
   */
  public String getLinuxOptions() {
    String options = new String();

    xmame = new Xmame(romeo);

    int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
    int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());

    if (majorNumber == 0 && minorNumber <= 66)
      options = dsp + timer + mixer + sound + samples + fakesound +
                samplefreq + bufsize + volume + audiodevice + mixerdevice +
		arbheight + autoframeskip + frameskipType + frameskip + window +
		throttle + scanlines + effect + gamma + brightness +
		geometry + autodouble + artwork + rotate + ror + rol + flipx +
                flipy + joystick + joytype +
		joydevname + mouse + analogstick + hotrod + hotrodse +
		usbpspad + rapidfire + beam + flicker +
		antialias + translucency + heightscale + widthscale + vectorres +
                cheat;
    else
      options = dsp + timer + mixer + sound + samples + fakesound +
                samplefreq + bufsize + volume + audiodevice + mixerdevice +
		arbheight + autoframeskip + frameskipType + frameskip + window +
		throttle + scanlines + effect + gamma + brightness +
		geometry + autodouble + artwork + backdrop + overlay +
		bezel + artworkresolution + crop + rotate + autoror +
		autorol + ror + rol + flipx + flipy + joystick + joytype +
		joydevname + mouse + analogstick + hotrod + hotrodse +
		usbpspad + rapidfire + beam + flicker + intensity +
		antialias + translucency + heightscale + widthscale + vectorres +
                cheat;


    return options;
  }
  
  /**
   * This method returns other useful options.
   *
   * @return String Additional options
   *
   * @since  0.1.3pre3
   */
  public String getOtherOptions() {
    String otherOptions = "";
    String[] params = new String[0];
    String[] values = new String[0];

    config = new Config(new File(System.getProperty("user.home") +
                                 File.separator + ".romeo4xmame" +
				 File.separator + "Romeo.ini"));

    String OS = System.getProperty("os.name").toLowerCase();
    // System.out.println(OS);
    if (OS.indexOf("windows") > -1) {
      params = new String[]  {" -cfg_directory ", " -ctrlr_directory ",
                              " -diff_directory ", " -inipath ",
	                      " -input_directory ", " -memcard_directory ",
		              " -nvram_directory ", " -state_directory ",
		              " -artwork_directory ", " -snapshot_directory ",
		              " -samplepath ", " -hiscore_file ",
		              " -history_file ", " -mameinfo_file ",
		              " -cheat_file "};

      values = new String[]  {config.get("xmame.cfg_dir"),
                              config.get("xmame.ctrlr_dir"),
		              config.get("xmame.diff_dir"),
		              config.get("xmame.ini_dir"),
		              config.get("xmame.input_dir"),
		              config.get("xmame.memcard_dir"),
		              config.get("xmame.nvram_dir"),
		              config.get("xmame.state_dir"),
		              config.get("xmame.artwork_dir"),
		              config.get("xmame.snap_dir"),
		              config.get("xmame.sample_dir"),
		              config.get("xmame.hiscore.dat_path"),
		              config.get("xmame.history.dat_path"),
		              config.get("xmame.mameinfo.dat_path"),
		              config.get("xmame.cheat.dat_path")};
    }
    else {
      xmame = new Xmame(romeo);

      int majorNumber = xmame.getXmameMajorRevisionNumber(romeo.games.getXmamePath());
      int minorNumber = xmame.getXmameMinorRevisionNumber(romeo.games.getXmamePath());

      if (majorNumber == 0 && minorNumber <= 60) {
        params = new String[] {" -ctrlr_directory ",
		               " -artworkpath ",
                               " -screenshotdir ",
		               " -samplepath ",
                               " -hiscorefile ",
		               " -historyfile ",
                               " -mameinfofile ",
		               " -cheatfile "};

        values = new String[]  {config.get("xmame.ctrlr_dir"),
		                config.get("xmame.artwork_dir"),
		                config.get("xmame.snap_dir"),
		                config.get("xmame.sample_dir"),
		                config.get("xmame.hiscore.dat_path"),
		                config.get("xmame.history.dat_path"),
		                config.get("xmame.mameinfo.dat_path"),
		                config.get("xmame.cheat.dat_path")};
      }
      else {
        params = new String[]  {" -cfg_directory ", " -ctrlr_directory ",
                                " -diff_directory ", " -inipath ",
	                        " -input_directory ", " -memcard_directory ",
		                " -nvram_directory ", " -state_directory ",
		                " -artwork_directory ", " -snapshot_directory ",
		                " -samplepath ", " -hiscore_file ",
		                " -history_file ", " -mameinfo_file ",
		                " -cheat_file "};

        values = new String[]  {config.get("xmame.cfg_dir"),
                                config.get("xmame.ctrlr_dir"),
		                config.get("xmame.diff_dir"),
		                config.get("xmame.ini_dir"),
		                config.get("xmame.input_dir"),
		                config.get("xmame.memcard_dir"),
		                config.get("xmame.nvram_dir"),
		                config.get("xmame.state_dir"),
		                config.get("xmame.artwork_dir"),
		                config.get("xmame.snap_dir"),
		                config.get("xmame.sample_dir"),
		                config.get("xmame.hiscore.dat_path"),
		                config.get("xmame.history.dat_path"),
		                config.get("xmame.mameinfo.dat_path"),
		                config.get("xmame.cheat.dat_path")};
      }
    }

    for (int i = 0; i < values.length; i++) {
      if (values[i].length() > 0)
        otherOptions = otherOptions + params[i] + values[i];
      else
        otherOptions = otherOptions;
    }
    
    return otherOptions;
  }
} // End Options.java
