
/*==============================================================================
 *
 * (#)Settings.java
 * created   2002/12/10
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *==============================================================================
 */

package com.miami.romeo.settings;

//****** imports
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.DefaultListModel;

import com.miami.romeo.main.Romeo;
import com.miami.romeo.main.DataIO;
import com.miami.romeo.graphics.DialogSeparator;
import com.miami.romeo.main.table.TableRenderer;
import com.miami.romeo.graphics.ColorSwatch;
import com.miami.romeo.main.list.JListCellRenderer;
import com.miami.romeo.main.list.ListItem;
import com.miami.romeo.config.*;
import com.miami.romeo.xmame.*;
import com.miami.romeo.internet.*;

/**
 * Settings.<br>
 * This is the settings window.
 *
 * @author   $Author: Stefano Bolli
 * @version  $Revision: 1.11 $Date: 2004/05/25 01:20:27 $
 */
public class Settings extends JFrame implements KeyEventDispatcher {
  //******** Classes needed by Settings.java
  // Main class
  Romeo romeo = null;
  // This class contains some utilities
  Utils utils = new Utils();
  // Path to configuration file
  private String config_name = System.getProperty("user.home") +
                               File.separator + ".romeo4xmame" +
                               File.separator + "Romeo.ini";
  // Configuration file
  private File config_file = new File(config_name);
  // Class to read and write configuration file
  Config config = new Config(config_file);
  // This class dialogs with xmame executable
  Xmame xmame = null;
  DataIO dataio = null;
  // Simple browser
  Hyperlink hyperlink = null;
  // Custom renderer
  TableRenderer renderer = null;
  // Color swatch
  ColorSwatch cs = null;
  // Dialog separator
  DialogSeparator ds = null;
  // Filechoosers...
  JFileChooser filechooser  = null;
  JFileChooser filechooser2 = null;

  //******** First panel' s components
  String info1                  = utils.getString("Settings.panel1_label");
  JCheckBox showSplashScreenBox = null;
  JCheckBox loadListOfGamesBox  = null;
  JComboBox chooseListBox       = null;
  JCheckBox newReleaseBox       = null;
  JCheckBox iconifyWindowsBox   = null;
  JComboBox languageComboBox    = null;
  JLabel languageCreditLabel    = null;
  GeneralSettings gSettings     = null;

  //******** Second panel' s components
  // Skin
  String info2           = utils.getString("Settings.panel2_label");
  JCheckBox skinCheckBox = null;
  JLabel skinLabel       = null;
  JLabel skinBoxLabel    = null;
  JComboBox skinBox      = null;
  JButton reloadSkins    = null;
  JCheckBox useSkin      = null;
  JLabel skinlf          = null;
  JLabel javatoo         = null;

  // Icons
  JLabel iconSetLabel            = null;
  JComboBox chooseIconSetBox     = null;
  JLabel previewIconLabel1       = null;
  JLabel previewIconLabel2       = null;
  JLabel previewIconLabel3       = null;
  JLabel iconSetCreditLabel      = null;

  // List of games
  public JLabel  interCellSpacingLabel         = null;
  public JSlider interCellSpacingSlider        = null;
  public JLabel rowHeightLabel                 = null;
  public JSlider rowHeightSlider               = null;
  public JComboBox fontBox                     = null;
  public JComboBox fontSizeBox                 = null;
  public JComboBox fontStyleBox                = null;
  Vector fonts                                 = null;
  public JCheckBox showHorizontalLinesCheckBox = null;
  public JCheckBox showVerticalLinesCheckBox   = null;
  public JButton extTablesColor                = null;
  public JButton intTablesColor                = null;
  public JCheckBox showControls                = null;
  LnFSettings lnfSettings                      = null;

  //******** Third panel' s components
  // xmame executables stuff
  String info3                = utils.getString("Settings.panel3_label");
  JTextField xmameField       = null;
  JList xmameExecList         = null;
  JButton addXmameToList      = null;
  JButton removeXmameFromList = null;
  JButton setXmameAsDefault   = null;
  DefaultListModel model      = null;
  // xmame directories
  // First tab
  JTextField romField        = null;
  JButton romButton          = null;
  JList romDirList            = null;
  JButton addRomDirToList     = null;
  JButton removeRomDirFromList = null;
  DefaultListModel model2     = null;
  JTextField snapField        = null;
  JButton snapButton          = null;
  JTextField flyerField      = null;
  JButton flyerButton        = null;
  JTextField marqueeField    = null;
  JButton marqueeButton      = null;
  JTextField cabinetField    = null;
  JButton cabinetButton      = null;
  JTextField sampleField     = null;
  JButton sampleButton       = null;
  JTextField artworkField    = null;
  JButton artworkButton      = null;
  // Second tab
  JTextField iniField         = null;
  JButton iniButton           = null;
  JTextField cfgField         = null;
  JButton cfgButton           = null;
  JTextField nvramField       = null;
  JButton nvramButton         = null;
  JTextField memcardField     = null;
  JButton memcardButton       = null;
  JTextField inputField       = null;
  JButton inputButton         = null;
  JTextField stateField       = null;
  JButton stateButton         = null;
  JTextField diffField        = null;
  JButton diffButton          = null;
  // Third tab
  JTextField ctrlrField       = null;
  JButton ctrlrButton         = null;
  // Extra xmame files
  // Text Field for cheat.dat
  JTextField cheatField       = null;
  JButton cheatButton         = null;
  // Text Field for hiscore.dat
  JTextField hiscoreField     = null;
  JButton hiscoreButton       = null;
  // Text Field for history.dat
  JTextField historyField     = null;
  JButton historyButton       = null;
  // Text Field for mameinfo.dat
  JTextField mameinfoField    = null;
  JButton mameinfoButton      = null;
  // Text Field for catver.ini
  JTextField catverField      = null;
  JButton catverButton        = null;
  XmameSettings xSettings     = null;

  //****** Fourth panel' s components
  String info4               = utils.getString("Settings.panel4_label");
  DataStoringSettings dSettings = null;
  JTextField mysqlUser = null;
  JPasswordField mysqlPasswd = null;
  JTextField mysqlHostname = null;
  JTabbedPane tPane = null;
  // APanel aP0 = null;
  // APanel aP1 = null;
  // APanel aP2 = null;
  JRadioButton xmlButton = null;
  JRadioButton sqlButton = null;
  JRadioButton txtButton = null;

  //****** Fifth panel' s components
  String info5               = utils.getString("Settings.panel5_label");
  JTextField nameField       = null;
  JTextField mailField       = null;
  JTextField smtpField       = null;
  JTextField browserField    = null;
  JTextField downRomsField   = null;
  JComboBox imageType        = null;
  JComboBox server           = null;
  JTextField downSampleField = null;
  JTextField downArtworkField= null;
  InternetSettings iSettings = null;

  DefaultListModel listModel   = null;
  JList optionList             = null;

  JPanel panel               = null;
  JPanel northPanel          = null;
  JPanel centerPanel         = null;
  JPanel southPanel          = null;

  JLabel infoLabel           = null;

  DefaultFocusManager dfocus = null;

  /**
   * The constructor creates the window.
   *
   * @param romeo The caller
   */
  public Settings(Romeo romeo) {
    this.romeo = romeo;

    // setLayout(new BorderLayout());
    getContentPane().setLayout(new BorderLayout());

    // Icon
    Image icon = Toolkit.getDefaultToolkit().getImage(
                    getClass().getResource("/images/icons/16x16/Settings.png"));
    setIconImage(icon);

    // Title
    setTitle(utils.getString("Settings.Title"));

    setSize(660, 485);
    setResizable(false);

    // Create a reference of the panels
    gSettings   = new GeneralSettings();
    lnfSettings = new LnFSettings();
    xSettings   = new XmameSettings();
    dSettings   = new DataStoringSettings();
    iSettings   = new InternetSettings();

    JPanel listPanel = new JPanel(new BorderLayout());
    listPanel.setBorder(new EmptyBorder(10, 10, 10, 10));
    listPanel.add(createOptionList(), BorderLayout.CENTER);

    getContentPane().add(listPanel, BorderLayout.WEST);
    
    getContentPane().add(gSettings, BorderLayout.CENTER);

    // Button to save the configuration file
    ImageIcon iconSave = new ImageIcon(getClass().getResource(
                                              "/images/icons/24x24/Save.png"));
    JButton saveButton = new JButton(utils.getString("Settings.Save"));
    saveButton.setIcon(iconSave);
    saveButton.addActionListener(new SaveAction());

    // Dispose window
    ImageIcon iconCancel = new ImageIcon(getClass().getResource(
                                         "/images/icons/24x24/Cancel.png"));
    JButton cancelButton = new JButton(utils.getString("Settings.Cancel"));
    cancelButton.setIcon(iconCancel);
    cancelButton.addActionListener(new CancelAction());

    JPanel p = new JPanel();
    p.add(Box.createRigidArea(new Dimension(10, 1)));
    p.add(Box.createRigidArea(new Dimension(10, 1)));

    Vector vector = new Vector();
    vector.addElement(p.add(saveButton));
    vector.addElement(p.add(cancelButton));

    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new BorderLayout());
    buttonPanel.add(p, BorderLayout.EAST);

    getContentPane().add(buttonPanel, BorderLayout.SOUTH);

    // Center the window
    Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
    Rectangle frameDim = getBounds();
    setLocation((screenDim.width - frameDim.width) / 2,
                (screenDim.height - frameDim.height) / 2);

    addComponentListener(new ComponentAdapter(){
      public void componentMoved(ComponentEvent e){
        SwingUtilities.updateComponentTreeUI(Settings.this);
      }

      public void componentResized(ComponentEvent e) {
        // not needed!
      }
    });

    // Create a focus manager
    dfocus = new DefaultFocusManager();
    // Set as the current focus manager
    KeyboardFocusManager.setCurrentKeyboardFocusManager(dfocus);
    // Add a keyboard stroke interceptor to listen for keys released
    dfocus.addKeyEventDispatcher(this);

    show();
  }

  /**
   * This method is called by the current KeyboardFocusManager requesting
   * that this KeyEventDispatcher dispatch the specified event on its behalf.
   *
   * @param  e The KeyEvent to dispatch
   *
   * @return  <code>true</code> if the key event has been consumed by
   *          this method and <code>false</code> if it has not.
   *
   * @see     #textFieldHasFocus()
   * @see     #getTextField()
   *
   * @since   0.1.3pre1
   */
  public boolean dispatchKeyEvent(KeyEvent e) {
    // Make sure the event is not consumed
    boolean consumed = e.isConsumed();

    // Receive released events
    if (e.getID() == KeyEvent.KEY_RELEASED) {
      // this method retrieves the pressed characters and verifies that
      // they are not control characters. We also retrieve the contents
      // of the text field and check that it is not empty (to avoid annoying
      // the user with suggestions in an empty field).
      if (textFieldHasFocus() && !consumed) {
        JTextField editor = getTextField();
        char ch = e.getKeyChar();
        if (ch != KeyEvent.CHAR_UNDEFINED && !Character.isISOControl(ch)) {
          int pos = editor.getCaretPosition();
          String str = editor.getText();
          if (str.length() != 0) {
            File f = new File(str);
            if (f.exists()) {
              if (editor == xmameField)
                addXmameToList.setEnabled(true);
              else
                addRomDirToList.setEnabled(true);
	    }
            else {
              if (editor == xmameField)
                addXmameToList.setEnabled(false);
              else
                addRomDirToList.setEnabled(false);;
	    }
          }
	}
      }

      consumed = true;
    }

    return consumed; // true means not passed on
  }

  /**
   * This method returns true if the JTextField where to set the path to xmame in is
   * the focus owner, false otherise.
   *
   * @return <code>True</code> if the JTextField where to set the path to xmame in is
   *         the focus owner, <code>false</code> otherise.
   *
   * @since  0.1.3pre2
   */
  public boolean textFieldHasFocus() {
    Component comp = dfocus.getFocusOwner();

    if (comp == xmameField || comp == romField)
      return true;
    else
      return false;
  }

  /**
   * This method returns the JTextField that owns focus.
   *
   * @return The <code>JTextField</code> that owns focus
   *
   * @since  0.1.3pre2
   */
  public JTextField getTextField() {
    Component comp = dfocus.getFocusOwner();

    return (JTextField)comp;
  }

  /**
   * This method returns a scrollpane for the options list.
   *
   * @return <code>JScrollPane</code> for the option list
   */
  public JScrollPane createOptionList() {
    // Use a list model that allows for updates
    listModel = new DefaultListModel();

    listModel.addElement(info1);
    listModel.addElement(info2);
    listModel.addElement(info3);
    listModel.addElement(info4);
    listModel.addElement(info5);

    optionList = new JList(listModel);
    optionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    optionList.setCellRenderer(new SettingsListCellRenderer());

    // Add a mouse listener to the list
    optionList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        int index = optionList.locationToIndex(e.getPoint());
	
	addPanel(index);
      }
    });

    optionList.setSelectedIndex(0);

    JScrollPane listScroll = new JScrollPane(optionList);

    return listScroll;
  }
  
  /**
   * This method adds a panel to the content pane.
   *
   * @param index The identifier of the panel to add
   */
  public void addPanel(int index) {
    removePanel();

    if (index == 0) {
      getContentPane().add(gSettings, BorderLayout.CENTER);
      SwingUtilities.updateComponentTreeUI(getContentPane());
    }
    else if (index == 1) {
      getContentPane().add(lnfSettings, BorderLayout.CENTER);
      SwingUtilities.updateComponentTreeUI(getContentPane());
    }
    else if (index == 2) {
      getContentPane().add(xSettings, BorderLayout.CENTER);
      SwingUtilities.updateComponentTreeUI(getContentPane());
    }
    else if (index == 3) {
      getContentPane().add(dSettings, BorderLayout.CENTER);
      SwingUtilities.updateComponentTreeUI(getContentPane());
    }
    else if (index == 4) {
      getContentPane().add(iSettings, BorderLayout.CENTER);
      SwingUtilities.updateComponentTreeUI(getContentPane());
    }
  }
  
  /**
   * This method removes a panel from the content pane.
   */
  protected void removePanel() {
    Component[] comp = getContentPane().getComponents();
    for (int i = 0; i < comp.length; i++) {
      if ((comp[i] instanceof GeneralSettings) ||
          (comp[i] instanceof LnFSettings) ||
	  (comp[i] instanceof XmameSettings) ||
	  (comp[i] instanceof DataStoringSettings) ||
	  (comp[i] instanceof InternetSettings)) {
	getContentPane().remove(comp[i]);
	SwingUtilities.updateComponentTreeUI(getContentPane());
	break;
      }
    }
  }

  /**
   * This class creates a panel that contains general options.
   */
  class GeneralSettings extends JPanel {

    public GeneralSettings() {
      setLayout(new BorderLayout());
      setBorder(new EmptyBorder(10, 10, 10, 10));

      northPanel = new JPanel(new BorderLayout());

      infoLabel = new JLabel(info1);
      infoLabel.setFont(getFont().deriveFont(1, 12));
      northPanel.add(infoLabel, BorderLayout.NORTH);

      ds = new DialogSeparator();
      northPanel.add(ds, BorderLayout.SOUTH);

      add(northPanel, BorderLayout.NORTH);

      centerPanel = new JPanel(new BorderLayout());

      centerPanel.add(createCommonOptionPanel(), BorderLayout.NORTH);

      centerPanel.add(createLanguageOptionPanel(), BorderLayout.CENTER);

      add(centerPanel, BorderLayout.CENTER);

      JPanel southPanel = new JPanel(new BorderLayout());

      southPanel.add(new DialogSeparator(), BorderLayout.CENTER);

      add(southPanel, BorderLayout.SOUTH);
    }
  }

  /**
   * This method returns a panel containing common options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createCommonOptionPanel() {
    JPanel commonOptionsPanel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    commonOptionsPanel.setLayout(new BoxLayout(commonOptionsPanel,
                                               BoxLayout.Y_AXIS));
    commonOptionsPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    // Splash screen option
    showSplashScreenBox = new JCheckBox();
    showSplashScreenBox.setText(
                     utils.getString("Settings.general_splashscreen_checkbox"));
    showSplashScreenBox.setSelected(config.getBoolean("Show_splashscreen"));
    commonOptionsPanel.add(showSplashScreenBox);

    newReleaseBox = new JCheckBox();
    newReleaseBox.setText(
                      utils.getString("Settings.general_newRelease_checkbox"));
    newReleaseBox.setSelected(config.getBoolean("Romeo.New_Release"));
    commonOptionsPanel.add(newReleaseBox);

    // If selected Romeo will iconify its windows before
    // running a game
    iconifyWindowsBox = new JCheckBox();
    iconifyWindowsBox.setText(utils.getString("Settings.general_iconifyWindows_checkbox"));
    iconifyWindowsBox.setSelected(config.getBoolean("Iconify_before_playing"));
    commonOptionsPanel.add(iconifyWindowsBox);

    panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 0, 5, 0));
    panel.setAlignmentX(LEFT_ALIGNMENT);

    loadListOfGamesBox = new JCheckBox();
    loadListOfGamesBox.setAlignmentX(LEFT_ALIGNMENT);
    loadListOfGamesBox.setText(
                         utils.getString("Settings.general_loadList_checkbox"));
    loadListOfGamesBox.setSelected(config.getBoolean("Load_list_of_games"));
    panel.add(loadListOfGamesBox);
    panel.add(Box.createHorizontalStrut(10));

    commonOptionsPanel.add(panel);

    String[] lists = {utils.getString("Tree.games.all_label"),
                      utils.getString("Tree.games.favorite_label"),
                      utils.getString("Tree.games.available_label"),
                      utils.getString("Tree.games.original_label"),
                      utils.getString("Tree.games.cloned_label"),
                      utils.getString("Tree.games.working_label"),
                      utils.getString("Tree.games.nonworking_label"),
                      "Neo-Geo",
                      "CPS1",
                      "CPS2"};

    chooseListBox = new JComboBox(lists);

    int choosen_list = config.getInt("Load_choosen_list");

    if (choosen_list > -1)
      chooseListBox.setSelectedIndex(choosen_list);
    else
      chooseListBox.setSelectedIndex(0);

    chooseListBox.setAlignmentX(CENTER_ALIGNMENT);
    panel.add(chooseListBox);

    panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createTitledBorder("Commons"));
    panel.add(commonOptionsPanel);

    return panel;
  }

  /**
   * This method returns a panel containing language options.
   *
   * @return <code>JPanel</code>
   *
   * @since 0.1.3
   */
  public JPanel createLanguageOptionPanel() {
    JPanel languagePanel = new JPanel() {
      //Don't allow us to stretch vertically.
      public Dimension getMaximumSize() {
        Dimension pref = getPreferredSize();
        return new Dimension(Integer.MAX_VALUE, pref.height);
      }
    };
    languagePanel.setLayout(new BoxLayout(languagePanel, BoxLayout.Y_AXIS));
    languagePanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

    JLabel languageWarning = new JLabel();
    languageWarning.setAlignmentX(LEFT_ALIGNMENT);
    languageWarning.setText("<html>" +
                            utils.getString("Settings.language_warning") +
	 		    "</html>");
    languagePanel.add(languageWarning);

    panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.setBorder(BorderFactory.createEmptyBorder(10, 0, 5, 0));
    panel.setAlignmentX(LEFT_ALIGNMENT);

    JLabel chooseLanguageLabel = new JLabel();
    chooseLanguageLabel.setText(utils.getString("Settings.language_label"));
    chooseLanguageLabel.setAlignmentX(LEFT_ALIGNMENT);
    panel.add(chooseLanguageLabel);
    panel.add(Box.createHorizontalStrut(10));

    languageCreditLabel = new JLabel();
    languageCreditLabel.setAlignmentX(LEFT_ALIGNMENT);

    // This components lists available language files
    languageComboBox = new JComboBox();

    scanLanguageDir();

    languageComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox) e.getSource();
	String l = cb.getSelectedItem().toString();

	if (l.endsWith("Italian") || l.endsWith("English"))
	  languageCreditLabel.setText("<html><br>Stefano Bolli " +
	                           "stefanobolli@users.sourceforge.net</html>");
	else if (l.endsWith("Spanish"))
          languageCreditLabel.setText("<html><br>Luis Oscar Villalvazo " +
	                              "luisoscar@users.sourceforge.net</html>");
      }
    });
    languageComboBox.setSelectedIndex(config.getInt("Language.index"));
    languageComboBox.setAlignmentX(CENTER_ALIGNMENT);
    panel.add(languageComboBox);
    panel.add(Box.createHorizontalStrut(10));

    // Button to rescan language files dir
    JButton rescanLanguages = new JButton();
    rescanLanguages.setIcon(utils.createImageIcon16x16("Reload.png"));
    rescanLanguages.setToolTipText(utils.getString("Settings.reload_languages"));
    rescanLanguages.addActionListener(new rescanLanguageDirAction());
    rescanLanguages.setAlignmentX(RIGHT_ALIGNMENT);
    rescanLanguages.setMinimumSize(new Dimension(24, 24));
    rescanLanguages.setPreferredSize(new Dimension(24, 24));
    rescanLanguages.setMaximumSize(new Dimension(24, 24));
    panel.add(rescanLanguages);

    languagePanel.add(panel);
    //languagePanel.add(Box.createVerticalStrut(10));
    languagePanel.add(languageCreditLabel);

    panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
    panel.setBorder(BorderFactory.createTitledBorder(utils.getString("Settings.language_panel_label")));
    panel.add(languagePanel);

    return panel;
  }
  
  /**
   * This class rescans language file dir.
   */
  public class rescanLanguageDirAction implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      scanLanguageDir();
    }
  }
  
  /**
   * This method rescans the language file dir and updates the specific
   * combo box.
   */
  public void scanLanguageDir() {
    ActionListener[] al = languageComboBox.getActionListeners();

    for (int i = 0; i < al.length; i++) {
      languageComboBox.removeActionListener(al[i]);
    }

    // Get number of items in the list
    int count = languageComboBox.getItemCount();

    // If count > 0 removes all items
    if (count > 0)
      languageComboBox.removeAllItems();

    File languagesDir = new File(System.getProperty("user.home") +
                                 File.separator + ".romeo4xmame" +
				 File.separator + "Languages");
    // A filter...
    FileNameFilter filter = new FileNameFilter();

    // List of language file
    String[] languagesList = languagesDir.list(filter);

    // How many language files?
    if (languagesList.length > 0) {
      for (int i = 0; i < languagesList.length; i++) {
	int idx_p = languagesList[i].indexOf('.');
        languageComboBox.addItem(" " + languagesList[i].substring(0, idx_p));
      }
    }
    else {
      languageComboBox.addItem(" No file available");
    }

    for (int i = 0; i < al.length; i++) {
      languageComboBox.addActionListener(al[i]);
    }
  }
  
  /**
   * Filter for language files.
   */
  class FileNameFilter implements FilenameFilter {
    public boolean accept(File dir, String name) {
      boolean acceptFile = false;
      if (name.endsWith(".ini"))
        acceptFile = true;
      return acceptFile;
    }
  }

  /**
   * This panel hosts look and feel options.
   */
  class LnFSettings extends JPanel {

    public LnFSettings() {
      setLayout(new BorderLayout());
      setBorder(new EmptyBorder(10, 10, 10, 10));

      northPanel = new JPanel(new BorderLayout());

      infoLabel = new JLabel(info2);
      infoLabel.setFont(getFont().deriveFont(1, 12));
      northPanel.add(infoLabel, BorderLayout.NORTH);

      ds = new DialogSeparator();
      northPanel.add(ds, BorderLayout.SOUTH);
      
      add(northPanel, BorderLayout.NORTH);

      JTabbedPane lookTabbedPane = new JTabbedPane();

      //******** Panel for appearance options
      JPanel appearancePanel = new JPanel(new BorderLayout());

      SkinPanel skinPanel = new SkinPanel();

      appearancePanel.add(skinPanel, BorderLayout.CENTER);
      
      panel = new JPanel(new BorderLayout());
      panel.setBorder(BorderFactory.createTitledBorder(
                           utils.getString("Settings.appearance_icons_label")));

      JPanel IconSetPanel = new JPanel() {
        //Don't allow us to stretch vertically.
        public Dimension getMaximumSize() {
          Dimension pref = getPreferredSize();
          return new Dimension(Integer.MAX_VALUE, pref.height);
        }
      };

      IconSetPanel.setLayout(new BoxLayout(IconSetPanel, BoxLayout.Y_AXIS));
      IconSetPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

      JPanel chooseIconSetPanel = new JPanel() {
        //Don't allow us to stretch vertically.
        public Dimension getMaximumSize() {
          Dimension pref = getPreferredSize();
          return new Dimension(Integer.MAX_VALUE, pref.height);
        }
      };
      chooseIconSetPanel.setLayout(new BoxLayout(chooseIconSetPanel, BoxLayout.X_AXIS));
      chooseIconSetPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 10, 10));
      chooseIconSetPanel.setAlignmentX(LEFT_ALIGNMENT);

      iconSetLabel = new JLabel();
      iconSetLabel.setAlignmentX(LEFT_ALIGNMENT);
      iconSetLabel.setText(utils.getString("Settings.appearance_iconsLabel"));
      chooseIconSetPanel.add(iconSetLabel);
      chooseIconSetPanel.add(Box.createHorizontalStrut(10));

      String[] iconSets = {"Noia KDE (blue)",
                           "Noia KDE (red)",
                           "Kids Beta1"};

      chooseIconSetBox = new JComboBox(iconSets);
      chooseIconSetBox.setAlignmentX(CENTER_ALIGNMENT);

      chooseIconSetPanel.add(chooseIconSetBox);
      chooseIconSetPanel.add(Box.createHorizontalStrut(10));

      JPanel previewIconSetPanel = new JPanel() {
        //Don't allow us to stretch vertically.
        public Dimension getMaximumSize() {
          Dimension pref = getPreferredSize();
          return new Dimension(Integer.MAX_VALUE, pref.height);
        }
      };
      previewIconSetPanel.setLayout(new BoxLayout(previewIconSetPanel, BoxLayout.X_AXIS));
      //previewIconSetPanel.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 10));
      previewIconSetPanel.setAlignmentX(RIGHT_ALIGNMENT);

      previewIconLabel1 = new JLabel();
      previewIconLabel1.setAlignmentX(LEFT_ALIGNMENT);
      previewIconLabel1.setMinimumSize(new Dimension(24, 24));
      previewIconLabel1.setPreferredSize(new Dimension(24, 24));
      previewIconLabel1.setMaximumSize(new Dimension(24, 24));
      previewIconSetPanel.add(previewIconLabel1);
      previewIconSetPanel.add(Box.createHorizontalStrut(10));
      previewIconLabel2 = new JLabel();
      previewIconLabel2.setAlignmentX(CENTER_ALIGNMENT);
      previewIconLabel2.setMinimumSize(new Dimension(24, 24));
      previewIconLabel2.setPreferredSize(new Dimension(24, 24));
      previewIconLabel2.setMaximumSize(new Dimension(24, 24));
      previewIconSetPanel.add(previewIconLabel2);
      previewIconSetPanel.add(Box.createHorizontalStrut(10));
      previewIconLabel3 = new JLabel();
      previewIconLabel3.setAlignmentX(RIGHT_ALIGNMENT);
      previewIconLabel3.setMinimumSize(new Dimension(24, 24));
      previewIconLabel3.setPreferredSize(new Dimension(24, 24));
      previewIconLabel3.setMaximumSize(new Dimension(24, 24));
      previewIconSetPanel.add(previewIconLabel3);

      chooseIconSetPanel.add(previewIconSetPanel);

      IconSetPanel.add(chooseIconSetPanel);

      iconSetCreditLabel = new JLabel();
      iconSetCreditLabel.setAlignmentX(LEFT_ALIGNMENT);
      IconSetPanel.add(iconSetCreditLabel);


      IconSetPanel.add(Box.createVerticalStrut(10));

      JLabel changeIconSetLabel = new JLabel();
      changeIconSetLabel.setAlignmentX(LEFT_ALIGNMENT);
      changeIconSetLabel.setText(utils.getString(
                                       "Settings.appearance_iconsChangeLabel"));
      IconSetPanel.add(changeIconSetLabel);

      chooseIconSetBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          JComboBox cb = (JComboBox) e.getSource();
	  int iconSet = cb.getSelectedIndex();

          if (iconSet == 0) {
            previewIconLabel1.setIcon(new ImageIcon(getClass().getResource("/images/icons/24x24/Exec.png")));
            previewIconLabel2.setIcon(new ImageIcon(getClass().getResource("/images/icons/24x24/Save.png")));
            previewIconLabel3.setIcon(new ImageIcon(getClass().getResource("/images/icons/24x24/Settings.png")));
            iconSetCreditLabel.setText(utils.getString("Settings.appearance_iconset1") + " http://www.carlitus.net/");
          }
          else if (iconSet == 1) {
            previewIconLabel1.setIcon(new ImageIcon(getClass().getResource("/images/icons2/24x24/Exec.png")));
            previewIconLabel2.setIcon(new ImageIcon(getClass().getResource("/images/icons2/24x24/Save.png")));
            previewIconLabel3.setIcon(new ImageIcon(getClass().getResource("/images/icons2/24x24/Settings.png")));
            iconSetCreditLabel.setText(utils.getString("Settings.appearance_iconset2") + " http://www.carlitus.net/");
          }
          else {
            previewIconLabel1.setIcon(new ImageIcon(getClass().getResource("/images/icons3/24x24/Exec.png")));
            previewIconLabel2.setIcon(new ImageIcon(getClass().getResource("/images/icons3/24x24/Save.png")));
            previewIconLabel3.setIcon(new ImageIcon(getClass().getResource("/images/icons3/24x24/Settings.png")));
            iconSetCreditLabel.setText(utils.getString("Settings.appearance_iconset3") + " http://www.everaldo.com/");
          }
        }
      });

      int choosen_iconset = config.getInt("Use_iconset");

      if (choosen_iconset > -1)
        chooseIconSetBox.setSelectedIndex(choosen_iconset);
      else if (choosen_iconset > iconSets.length)
        chooseIconSetBox.setSelectedIndex(0);
      else
        chooseIconSetBox.setSelectedIndex(0);

      panel.add(IconSetPanel, BorderLayout.CENTER);

      appearancePanel.add(panel, BorderLayout.SOUTH);
      
      // Add panel to tabbed pane
      lookTabbedPane.addTab(utils.getString("Settings.appearance_options_label"),
                            utils.createImageIcon16x16("Appearance.png"),
                            appearancePanel);

      JPanel tableControlsPanel = new JPanel(new BorderLayout());
      tableControlsPanel.setBorder(BorderFactory.createTitledBorder(
                                utils.getString("Settings.listofgames_options_label")));

      panel = new JPanel();
      panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
      panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

      JPanel fontPanel = new JPanel();
      fontPanel.setLayout(new BoxLayout(fontPanel, BoxLayout.X_AXIS));

      JLabel fontLabel = new JLabel("Font:");
      fontLabel.setAlignmentX(LEFT_ALIGNMENT);
      fontPanel.add(fontLabel);
      fontPanel.add(Box.createHorizontalStrut(10));

      fonts = new Vector();

      /*
       * Get the available fonts from the GraphicsEnviroment
       * and put them into a Vector
       */
      GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
      String envfonts[] = ge.getAvailableFontFamilyNames();
      for (int i = 0; i < envfonts.length; i++) {
        fonts.addElement(envfonts[i]);
      }
      
      ItemListener il = new ItemListener() {
        /*
         * Detects a state change in any of the Lists. Resets the variable corresponding
         * to the selected item in a particular List. Invokes changeFont with the currently
         * selected fontname, style and size attributes.
         */
        public void itemStateChanged(ItemEvent e) {
	  String siChoice, fontchoice;
          int index;

          if ( e.getStateChange() != ItemEvent.SELECTED ) {
            return;
          }

          Object list = e.getSource();

          if (list == fontBox) {
            fontchoice = (String)fontBox.getSelectedItem();
	    index = fontBox.getSelectedIndex();
	    config.add("Table.font", fontchoice);
	    config.add("Table.font_index", index);
          } else if (list == fontStyleBox) {
            index = fontStyleBox.getSelectedIndex();
	    config.add("Table.font_style", index);
          } else {
            siChoice = (String)fontSizeBox.getSelectedItem();
	    index = fontSizeBox.getSelectedIndex();
	    config.add("Table.font_size", siChoice);
	    config.add("Table.font_size_index", index);
          }

	  config.save();

	  Component comp = romeo.games.columnModel1.getColumn(
	                     0).getCellRenderer().getTableCellRendererComponent(
	                     romeo.games.table, romeo.games.table.getValueAt(0, 0),
			     false, false, 0, 0);
	  Color c = comp.getBackground();

	  renderer = new TableRenderer(c);

	  String header = utils.getString("Table.column_played");

	  for (int i = 0; i < romeo.games.table.getColumnCount(); i++) {
	    if (!romeo.games.table.getColumnName(i).equals(header))
	        romeo.games.columnModel1.getColumn(i).setCellRenderer(renderer);
	      else
	        romeo.games.columnModel1.getColumn(i).setCellRenderer(
		                                                 romeo.games.iRenderer);
	  }
	  romeo.games.table.repaint();

	  comp = romeo.games.columnModel2.getColumn(
	                     0).getCellRenderer().getTableCellRendererComponent(
	                     romeo.games.table2, romeo.games.table2.getValueAt(0, 0),
			     false, false, 0, 0);
	  c = comp.getBackground();

          renderer = new TableRenderer(c);
	  romeo.games.columnModel2.getColumn(0).setCellRenderer(renderer);
	  romeo.games.table2.repaint();
	  romeo.games.columnModel3.getColumn(0).setCellRenderer(renderer);
	  romeo.games.table3.repaint();
        }
      };
      
      fontBox = new JComboBox(fonts);
      fontBox.setMaximumRowCount(9);
      fontBox.setSelectedIndex(config.getInt("Table.font_index"));
      fontBox.setAlignmentX(CENTER_ALIGNMENT);
      fontBox.addItemListener(il);
      fontPanel.add(fontBox);

      panel.add(fontPanel);
      panel.add(Box.createVerticalStrut(10));

      JPanel fontPanel2 = new JPanel();
      fontPanel2.setLayout(new BoxLayout(fontPanel2, BoxLayout.X_AXIS));

      JLabel fontSizeLabel = new JLabel("Font size:");
      fontSizeLabel.setAlignmentX(LEFT_ALIGNMENT);
      fontPanel2.add(fontSizeLabel);
      fontPanel2.add(Box.createHorizontalStrut(10));

      fontSizeBox = new JComboBox(new Object[]{"10", "12", "14", "16", "18"});
      fontSizeLabel.setAlignmentX(CENTER_ALIGNMENT);
      fontSizeBox.setMaximumRowCount(9);
      fontSizeBox.setSelectedIndex(config.getInt("Table.font_size_index"));
      fontSizeBox.addItemListener(il);
      fontPanel2.add(fontSizeBox);
      fontPanel2.add(Box.createHorizontalStrut(5));

      JPanel fontPanel3 = new JPanel();
      fontPanel3.setLayout(new BoxLayout(fontPanel3, BoxLayout.X_AXIS));

      JLabel fontStyleLabel = new JLabel("Font style:");
      fontStyleLabel.setAlignmentX(LEFT_ALIGNMENT);
      fontPanel3.add(fontStyleLabel);
      fontPanel3.add(Box.createHorizontalStrut(10));

      fontStyleBox = new JComboBox(new Object[]{"PLAIN",
                                                "BOLD",
                                                "ITALIC",
                                                "BOLD & ITALIC"});
      fontStyleBox.setMaximumRowCount(9);
      fontStyleBox.setSelectedIndex(config.getInt("Table.font_style"));
      fontStyleBox.setAlignmentX(CENTER_ALIGNMENT);
      fontStyleBox.addItemListener(il);
      fontPanel3.add(fontStyleBox);

      JPanel fontPanel4 = new JPanel();
      fontPanel4.setLayout(new BoxLayout(fontPanel4, BoxLayout.X_AXIS));
      fontPanel4.add(fontPanel2);
      fontPanel4.add(fontPanel3);

      panel.add(fontPanel4);

      tableControlsPanel.add(panel, BorderLayout.NORTH);

      JPanel centerPanel = new JPanel(new BorderLayout());
      centerPanel.setBorder(new EmptyBorder(5, 5, 5, 5));

      JPanel sliderPanel = new JPanel(new BorderLayout());

      JPanel sliderPanel1 = new JPanel(new BorderLayout());

      interCellSpacingLabel = new JLabel(utils.getString(
                                                    "Table.intercell_spacing"));
      interCellSpacingLabel.setBorder(new EmptyBorder(5, 5, 5, 5));
      sliderPanel1.add(interCellSpacingLabel, BorderLayout.NORTH);

      // Slider to set inter-cell spacing
      interCellSpacingSlider = new JSlider(JSlider.HORIZONTAL, 0, 10,
                                romeo.games.interCellSpacingSlider.getValue());
      interCellSpacingSlider.setBorder(new EmptyBorder(5, 5, 5, 5));
      interCellSpacingSlider.getAccessibleContext().setAccessibleName(
                                    utils.getString("Table.intercell_spacing"));
      interCellSpacingLabel.setLabelFor(interCellSpacingSlider);
      interCellSpacingSlider.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
	  int spacing = ((JSlider)e.getSource()).getValue();
          romeo.games.interCellSpacingSlider.setValue(spacing);
        }
      });
      sliderPanel1.add(interCellSpacingSlider, BorderLayout.SOUTH);
      
      sliderPanel.add(sliderPanel1, BorderLayout.WEST);

      JPanel sliderPanel2 = new JPanel(new BorderLayout());

      rowHeightLabel = new JLabel(utils.getString("Table.row_height"));
      rowHeightLabel.setBorder(new EmptyBorder(5, 5, 5, 5));
      sliderPanel2.add(rowHeightLabel, BorderLayout.NORTH);

      // Slider to set row height
      rowHeightSlider = new JSlider(JSlider.HORIZONTAL, 20, 100,
                       romeo.games.rowHeightSlider.getValue());
      rowHeightSlider.getAccessibleContext().setAccessibleName(
                                utils.getString("Table.row_height"));
      rowHeightLabel.setLabelFor(rowHeightSlider);
      rowHeightSlider.setBorder(new EmptyBorder(5, 5, 5, 5));
      rowHeightSlider.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
	  int height = ((JSlider)e.getSource()).getValue();
          romeo.games.rowHeightSlider.setValue(height);
        }
      });
      sliderPanel2.add(rowHeightSlider, BorderLayout.SOUTH);

      sliderPanel.add(sliderPanel2, BorderLayout.EAST);

      centerPanel.add(sliderPanel, BorderLayout.NORTH);
      
      JPanel p0 = new JPanel(new BorderLayout());

      JPanel buttonPanel = new JPanel(new BorderLayout());
      
      JLabel colorLabel = new JLabel(utils.getString(
                                          "Table.background_colors"));
      colorLabel.setBorder(new EmptyBorder(5, 5, 5, 5));
      buttonPanel.add(colorLabel, BorderLayout.WEST);

      JPanel p = new JPanel(new BorderLayout());
      
      cs = new ColorSwatch(new Color(
                                        config.getInt("Table.internal_red"),
                                        config.getInt("Table.internal_green"),
				        config.getInt("Table.internal_blue")));

      // Button to set internal scrollable table background color
      intTablesColor = new JButton();
      intTablesColor.setIcon(cs);
      intTablesColor.setBorder(new EmptyBorder(5, 5, 5, 5));
      intTablesColor.setPreferredSize(new Dimension(40, 40));
      intTablesColor.setMaximumSize(new Dimension(40, 40));
      intTablesColor.setToolTipText(utils.getString(
                                          "Table.internal_background_tooltip"));

      ActionListener l = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  if (romeo.games.table.getRowCount() > 0) {
            Color current = new Color(127, 255, 212);

	    Component comp = romeo.games.columnModel1.getColumn(
	                     0).getCellRenderer().getTableCellRendererComponent(
	                     romeo.games.table, romeo.games.table.getValueAt(0, 0),
			     false, false, 0, 0);
	    current = comp.getBackground();

	    // Bring up a color chooser
	    Color c = JColorChooser.showDialog(
		                               Settings.this,
	                                       utils.getString("ColorChooser.title"),
		                               current
	                                      );

            cs = new ColorSwatch(c);
	    intTablesColor.setIcon(cs);
	    romeo.games.intTablesColor.setIcon(cs);
            renderer = new TableRenderer(c);

	    String header = utils.getString("Table.column_played");

	    for (int i = 0; i < romeo.games.table.getColumnCount(); i++) {
	      if (!romeo.games.table.getColumnName(i).equals(header))
	        romeo.games.columnModel1.getColumn(i).setCellRenderer(renderer);
	      else
	        romeo.games.columnModel1.getColumn(i).setCellRenderer(
		                                                romeo.games.iRenderer);
	    }
	    romeo.games.table.repaint();

	    int r = c.getRed();
	    int g = c.getGreen();
	    int b = c.getBlue();

	    config = new Config(new File(System.getProperty("user.home") +
	                                 File.separator + ".romeo4xmame" +
					 File.separator + "Romeo.ini"));
	    config.add("Table.internal_red", r);
	    config.add("Table.internal_green", g);
	    config.add("Table.internal_blue", b);
	    config.save();
	  }
        }
      };
      intTablesColor.addActionListener(l);

      cs = new ColorSwatch(new Color(
                                        config.getInt("Table.external_red"),
                                        config.getInt("Table.external_green"),
				        config.getInt("Table.external_blue")));

      // Button to set external fixed tables background color
      extTablesColor = new JButton();
      extTablesColor.setIcon(cs);
      romeo.games.extTablesColor.setIcon(cs);
      extTablesColor.setBorder(new EmptyBorder(5, 5, 5, 5));
      extTablesColor.setPreferredSize(new Dimension(40, 40));
      extTablesColor.setMaximumSize(new Dimension(40, 40));
      extTablesColor.setToolTipText(utils.getString(
                                          "Table.external_background_tooltip"));

      l = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  if (romeo.games.table.getRowCount() > 0) {
            Color current = new Color(127, 255, 212);

	    Component comp = romeo.games.columnModel2.getColumn(
	                     0).getCellRenderer().getTableCellRendererComponent(
	                     romeo.games.table2, romeo.games.table2.getValueAt(0, 0),
			     false, false, 0, 0);
	    current = comp.getBackground();

	    // Bring up a color chooser
	    Color c = JColorChooser.showDialog(
		                               Settings.this,
	                                       utils.getString("ColorChooser.title"),
		                               current
	                                      );

	    cs = new ColorSwatch(c);
	    extTablesColor.setIcon(cs);
            renderer = new TableRenderer(c);
	    romeo.games.columnModel2.getColumn(0).setCellRenderer(renderer);
	    romeo.games.table2.repaint();
	    romeo.games.columnModel3.getColumn(0).setCellRenderer(renderer);
	    romeo.games.table3.repaint();

	    int r = c.getRed();
	    int g = c.getGreen();
	    int b = c.getBlue();

	    config = new Config(new File(System.getProperty("user.home") +
	                                 File.separator + ".romeo4xmame" +
					 File.separator + "Romeo.ini"));
	    config.add("Table.external_red", r);
	    config.add("Table.external_green", g);
	    config.add("Table.external_blue", b);
	    config.save();
	  }
        }
      };

      extTablesColor.addActionListener(l);

      p.add(intTablesColor, BorderLayout.WEST);
      p.add(extTablesColor, BorderLayout.EAST);
      
      JPanel bPanel = new JPanel(new BorderLayout());
      bPanel.add(p, BorderLayout.WEST);

      buttonPanel.add(bPanel, BorderLayout.CENTER);
      
      p0.add(buttonPanel, BorderLayout.NORTH);
      
      JPanel checkPanel = new JPanel(new BorderLayout());

      // Component to show/hide horizontal lines in the tables
      showHorizontalLinesCheckBox = new JCheckBox(
                                         utils.getString("Table.horz_lines"),
                       romeo.games.showHorizontalLinesCheckBox.isSelected());
      showHorizontalLinesCheckBox.setBorder(new EmptyBorder(5, 5, 5, 5));
      showHorizontalLinesCheckBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  boolean flag = ((JCheckBox)e.getSource()).isSelected();
	  romeo.games.showHorizontalLinesCheckBox.setSelected(flag);
	  romeo.games.table2.setShowHorizontalLines(flag);
          romeo.games.table2.repaint();
          romeo.games.table.setShowHorizontalLines(flag);
          romeo.games.table.repaint();
	  romeo.games.table3.setShowHorizontalLines(flag);
          romeo.games.table3.repaint();
	  config.add("Table.horz_lines", flag);
	  config.save();
	}
      });
      checkPanel.add(showHorizontalLinesCheckBox, BorderLayout.NORTH);

      // Component to show/hide vertical lines in the tables
      showVerticalLinesCheckBox = new JCheckBox(
                                         utils.getString("Table.vert_lines"),
                         romeo.games.showVerticalLinesCheckBox.isSelected());
      showVerticalLinesCheckBox.setBorder(new EmptyBorder(5, 5, 5, 5));
      showVerticalLinesCheckBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  boolean flag = ((JCheckBox)e.getSource()).isSelected();
	  romeo.games.showVerticalLinesCheckBox.setSelected(flag);
          romeo.games.table2.setShowVerticalLines(flag);
          romeo.games.table2.repaint();
          romeo.games.table.setShowVerticalLines(flag);
          romeo.games.table.repaint();
	  romeo.games.table3.setShowVerticalLines(flag);
          romeo.games.table3.repaint();
	  config.add("Table.vert_lines", flag);
	  config.save();
	}
      });
      checkPanel.add(showVerticalLinesCheckBox, BorderLayout.SOUTH);

      p0.add(checkPanel, BorderLayout.SOUTH);

      centerPanel.add(p0, BorderLayout.SOUTH);

      tableControlsPanel.add(centerPanel, BorderLayout.CENTER);

      JPanel p1 = new JPanel(new BorderLayout());
      p1.setBorder(new EmptyBorder(5, 5, 5, 5));

      showControls = new JCheckBox(utils.getString(
                                          "Settings.listofgames_show_options"));
      showControls.setBorder(new EmptyBorder(5, 5, 5, 5));
      showControls.setSelected(config.getBoolean("Tables.show_options"));
      p1.add(showControls, BorderLayout.WEST);
      
      tableControlsPanel.add(p1, BorderLayout.SOUTH);

      lookTabbedPane.addTab(utils.getString("Settings.listofgames_label"),
                            utils.createImageIcon16x16("List.png"),
			    tableControlsPanel);

      add(lookTabbedPane, BorderLayout.CENTER);

      add(new DialogSeparator(), BorderLayout.SOUTH);
    }
  }
  
  /**
   * Panel with skin options.
   */
  public class SkinPanel extends JPanel {

    public SkinPanel() {
      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
      setBorder(BorderFactory.createTitledBorder("Skin"));

      panel = new JPanel() {
        //Don't allow us to stretch vertically.
        public Dimension getMaximumSize() {
          Dimension pref = getPreferredSize();
          return new Dimension(Integer.MAX_VALUE, pref.height);
        }
      };
      panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
      //previewIconSetPanel.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 10));
      panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));

      // To delete if I wanna use the StateTransmitter
      skinCheckBox = new JCheckBox(utils.getString("Settings.appearance_skin_label"));
      skinCheckBox.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(skinCheckBox);

      boolean skinEnabled = config.getBoolean("Use_skin");

      JPanel skinCompPanel = new JPanel();
      skinCompPanel.setLayout(new BoxLayout(skinCompPanel, BoxLayout.X_AXIS));
      skinCompPanel.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 0));
      skinCompPanel.setAlignmentX(LEFT_ALIGNMENT);

      skinLabel = new JLabel();
      skinLabel.setText(utils.getString("Settings.appearance_skin_skinBox") + " ");
      skinLabel.setAlignmentX(LEFT_ALIGNMENT);
      skinLabel.setEnabled(skinEnabled);
      skinCompPanel.add(skinLabel);
      skinCompPanel.add(Box.createHorizontalStrut(10));

      // A combo box to list available skins
      skinBox = new JComboBox();
      skinBox.setRenderer(new ComboBoxRenderer(skinBox, utils.createImageIcon16x16("Tgz.png")));
      skinBox.setAlignmentX(CENTER_ALIGNMENT);
      
      scanSkindir();

      int skinIndex = config.getInt("Skin.index");
      if (skinIndex != -1)
        skinBox.setSelectedIndex(skinIndex);
      skinBox.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          JComboBox cb = (JComboBox) e.getSource();

	  if (!cb.getSelectedItem().toString().equals(" No skin available")) {
	    String skin = "skins" + File.separator +
	                  cb.getSelectedItem().toString().trim();
	    romeo.setSkinTheme(skin);
	  }
	}
      });
      skinBox.setEnabled(skinEnabled);
      skinCompPanel.add(skinBox);
      skinCompPanel.add(Box.createHorizontalStrut(10));

      // Button to rescan skins dir
      reloadSkins = new JButton();
      reloadSkins.setAlignmentX(RIGHT_ALIGNMENT);
      reloadSkins.setMinimumSize(new Dimension(24, 24));
      reloadSkins.setPreferredSize(new Dimension(24, 24));
      reloadSkins.setMaximumSize(new Dimension(24, 24));
      reloadSkins.setIcon(utils.createImageIcon16x16("Reload.png"));
      reloadSkins.setToolTipText(utils.getString(
                                  "Settings.appearance_skin_reloadSkins"));
      reloadSkins.addActionListener(new reloadSkinsAction());
      reloadSkins.setEnabled(skinEnabled);
      skinCompPanel.add(reloadSkins);
      panel.add(skinCompPanel);

      // If checked Romeo will load selected skin on startup
      useSkin = new JCheckBox();
      useSkin.setAlignmentX(LEFT_ALIGNMENT);
      useSkin.setText(utils.getString("Settings.appearance_skin_checkbox"));
      useSkin.setSelected(config.getBoolean("Use_skin"));
      useSkin.setEnabled(skinEnabled);
      panel.add(useSkin);

      skinCheckBox.addItemListener(new ItemListener() {
        public void itemStateChanged(ItemEvent e) {
	  skinLabel.setEnabled(e.getStateChange() == ItemEvent.SELECTED);
          skinBox.setEnabled(e.getStateChange() == ItemEvent.SELECTED);
          reloadSkins.setEnabled(e.getStateChange() == ItemEvent.SELECTED);
          useSkin.setEnabled(e.getStateChange() == ItemEvent.SELECTED);
        }
      });

      skinCheckBox.setSelected(skinEnabled);

      //******* l2fprod.com' logo
      final ImageIcon skinlfLogo = new ImageIcon(getClass().getResource(
                                         "/images/poweredbyskinlf.jpg"));

      skinlf = new JLabel(skinlfLogo, JLabel.CENTER);
      skinlf.setAlignmentX(LEFT_ALIGNMENT);
      skinlf.addMouseListener(new MouseListener() {
        public void mouseClicked(MouseEvent e) {
          final String homepage = "http://www.L2FProd.com/";

          Thread thread = new Thread() {
            public void run() {
              utils.goToUrl(homepage);
	    }
          };
          thread.start();
        }
        public void mouseEntered(MouseEvent e) {
          skinlf.setCursor(new Cursor(Cursor.HAND_CURSOR));
        }
        public void mouseExited(MouseEvent e) {
          // to handle
        }
        public void mousePressed(MouseEvent e) {
          // to handle
        }
        public void mouseReleased(MouseEvent e) {
          // to handle
        }
      });

      //******* javootoo.com' s logo
      final ImageIcon javatooLogo = new ImageIcon(getClass().getResource(
                                           "/images/linktojavootoo.gif"));

      javatoo = new JLabel(javatooLogo, JLabel.CENTER);
      javatoo.setAlignmentX(RIGHT_ALIGNMENT);
      javatoo.setToolTipText(utils.getString(
                                     "Settings.appearance_skin_linktojavatoo"));
      javatoo.addMouseListener(new MouseListener() {
        public void mouseClicked(MouseEvent e) {
          final String homepage = "http://javootoo.l2fprod.com/plaf/skinlf/index.php";

          Thread thread = new Thread() {
            public void run() {
              utils.goToUrl(homepage);
	    }
          };
          thread.start();
        }
        public void mouseEntered(MouseEvent e) {
          javatoo.setCursor(new Cursor(Cursor.HAND_CURSOR));
        }
        public void mouseExited(MouseEvent e) {
          // to handle
        }
        public void mousePressed(MouseEvent e) {
          // to handle
        }
        public void mouseReleased(MouseEvent e) {
          // to handle
        }
      });
      
      JPanel logoPanel = new JPanel();
      logoPanel.setLayout(new BoxLayout(logoPanel, BoxLayout.X_AXIS));
      logoPanel.setBorder(BorderFactory.createEmptyBorder(10, 0, 10, 20));
      logoPanel.setAlignmentX(LEFT_ALIGNMENT);
      logoPanel.add(Box.createHorizontalStrut(100));
      logoPanel.add(skinlf);
      logoPanel.add(Box.createHorizontalStrut(20));
      logoPanel.add(javatoo);
      panel.add(logoPanel);

      add(panel);
    }

  }
  
  /**
   * This class rescans skin dir.
   */
  public class reloadSkinsAction implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      scanSkindir();
    }
  }
  
  /**
   * This method scans skin dir and updates specific combo box.
   */
  public void scanSkindir() {
    ActionListener[] al = skinBox.getActionListeners();

    for (int i = 0; i < al.length; i++) {
      skinBox.removeActionListener(al[i]);
    }

    // Get number of items in the list
    int count = skinBox.getItemCount();

    // If count > 0 removes all items
    if (count > 0)
      skinBox.removeAllItems();

    // Skin directory
    File skinsDir = new File("skins" + File.separator);
    // Filter for skins
    SkinsFilter sfilter = new SkinsFilter();

    // Skin list
    String[] skinsList = skinsDir.list(sfilter);

    if (skinsList.length > 0) {
      //skinBox.addItem(" No skin");

      for (int i = 0; i < skinsList.length; i++) {
        skinBox.addItem(" " + skinsList[i]);
      }
    }
    else {
      skinBox.addItem(" No skin available");
    }

    for (int i = 0; i < al.length; i++) {
      skinBox.addActionListener(al[i]);
    }
  }
  
  /**
   * Filter for skins.
   */
  class SkinsFilter implements FilenameFilter {
    public boolean accept(File dir, String name) {
      boolean acceptFile = false;
      if (name.endsWith(".zip"))
        acceptFile = true;
      return acceptFile;
    }
  }

  /**
   * Panel that holds xmame options.
   */
  class XmameSettings extends JPanel {

    public XmameSettings() {
      setLayout(new BorderLayout());
      setBorder(new EmptyBorder(10, 10, 10, 10));

      JPanel northPanel = new JPanel(new BorderLayout());

      JLabel infoLabel = new JLabel(info3);
      infoLabel.setFont(getFont().deriveFont(1, 12));
      northPanel.add(infoLabel, BorderLayout.NORTH);

      ds = new DialogSeparator();
      northPanel.add(ds, BorderLayout.SOUTH);

      add(northPanel, BorderLayout.NORTH);

      JTabbedPane xmameTabbedPane = new JTabbedPane();

      //****** Panel for xmame options
      JPanel mamePanel = new JPanel();
      mamePanel.setLayout(new BoxLayout(mamePanel, BoxLayout.Y_AXIS));
      mamePanel.setBorder(BorderFactory.createTitledBorder(
                                 utils.getString("Settings.xmame_executable")));

      panel = new JPanel();
      panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
      panel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

      JLabel xmameLabel = new JLabel(utils.getString(
                                            "Settings.xmame_executable_label"));
      xmameLabel.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(xmameLabel);
      panel.add(Box.createVerticalStrut(5));

      JPanel nPanel = new JPanel();
      nPanel.setLayout(new BoxLayout(nPanel, BoxLayout.X_AXIS));
      nPanel.setAlignmentX(LEFT_ALIGNMENT);

      // Field for xmame executable file path
      xmameField = new JTextField();
      xmameField.setAlignmentX(LEFT_ALIGNMENT);
      xmameField.setMinimumSize(new Dimension(390, 24));
      xmameField.setPreferredSize(new Dimension(390, 24));
      xmameField.setMaximumSize(new Dimension(390, 24));
      nPanel.add(xmameField);
      nPanel.add(Box.createHorizontalStrut(10));

      JButton xmameButton = new JButton();
      xmameButton.setAlignmentX(RIGHT_ALIGNMENT);
      xmameButton.setIcon(utils.createImageIcon16x16("Exec.png"));
      xmameButton.setMinimumSize(new Dimension(24, 24));
      xmameButton.setPreferredSize(new Dimension(24, 24));
      xmameButton.setMaximumSize(new Dimension(24, 24));
      xmameButton.addActionListener(new OpenXmameExecutable());
      nPanel.add(xmameButton);

      panel.add(nPanel);
      panel.add(Box.createVerticalStrut(10));

      JPanel buttonPanel = new JPanel();
      buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
      buttonPanel.setAlignmentX(LEFT_ALIGNMENT);

      addXmameToList = new JButton(utils.getString(
                                              "Settings.xmame_add_executable"));
      addXmameToList.setAlignmentX(LEFT_ALIGNMENT);
      addXmameToList.setMinimumSize(new Dimension(134, 30));
      addXmameToList.setPreferredSize(new Dimension(134, 30));
      addXmameToList.setMaximumSize(new Dimension(134, 30));
      addXmameToList.setIcon(utils.createImageIcon16x16("Add.png"));
      addXmameToList.setEnabled(false);
      addXmameToList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  String s = xmameField.getText();
          File exec = new File(s);
	  // Check if the file is a xmame executable
	  xmame = new Xmame(romeo);
	  String version = xmame.getVersion(s);

          if (exec.exists() && version.startsWith("xmame") ||
	      version.startsWith("M.A.M.E.")) {
	    // Check if the executable has already been added to the list
	    int added = 0;
	    Object[] xmameExec = model.toArray();
	    String path;
	    if (xmameExec.length > 0) {
	      for (int i = 0; i < xmameExec.length; i++) {
	        ListItem item = (ListItem)model.getElementAt(i);
	        int DEFAULT = item.getValue().indexOf(" (DEFAULT)");

	        if (DEFAULT > 0)
	          path = item.getValue().substring(0, DEFAULT).trim();
	        else
	          path = item.getValue().toString();

	        if (path.equals(s)) {
	          added = 1;
		  break;
	        }
	      }
	    }

            if (added == 0) {
	      // Add the executable to the list
	      ListItem li = new ListItem(Color.cyan, s);
	      model.addElement(li);
	      xmameField.setText("");
	      addXmameToList.setEnabled(false);
	    }
	    else if (added == 1) {
	      JOptionPane.showMessageDialog(null, utils.getString(
	                                    "Messagebox.xmame_already_added"),
                                            utils.getString(
					    "Messagebox.error_title"),
                                            JOptionPane.ERROR_MESSAGE);
	      xmameField.setText("");
	      addXmameToList.setEnabled(false);
	    }
          }
          else {
	    xmameField.setText("");
	    addXmameToList.setEnabled(false);
	  }
	}
      });
      buttonPanel.add(addXmameToList);
      buttonPanel.add(Box.createHorizontalStrut(10));

      // This button removes an item from the list
      removeXmameFromList = new JButton(utils.getString(
                                           "Settings.xmame_remove_executable"));
      removeXmameFromList.setAlignmentX(CENTER_ALIGNMENT);
      removeXmameFromList.setMinimumSize(new Dimension(136, 30));
      removeXmameFromList.setPreferredSize(new Dimension(136, 30));
      removeXmameFromList.setMaximumSize(new Dimension(136, 30));
      removeXmameFromList.setIcon(utils.createImageIcon16x16("Remove.png"));
      removeXmameFromList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  // Remove selected xmame exec from the list
	  model.removeElementAt(xmameExecList.getSelectedIndex());
	  removeXmameFromList.setEnabled(false);
	  if (setXmameAsDefault.isEnabled())
	    setXmameAsDefault.setEnabled(false);
	}
      });
      removeXmameFromList.setEnabled(false);
      buttonPanel.add(removeXmameFromList);
      buttonPanel.add(Box.createHorizontalStrut(10));

      setXmameAsDefault = new JButton(utils.getString(
                                          "Settings.xmame_default_executable"));
      setXmameAsDefault.setIcon(utils.createImageIcon16x16("Ok.png"));
      setXmameAsDefault.setAlignmentX(RIGHT_ALIGNMENT);
      setXmameAsDefault.setMinimumSize(new Dimension(134, 30));
      setXmameAsDefault.setPreferredSize(new Dimension(134, 30));
      setXmameAsDefault.setMaximumSize(new Dimension(134, 30));
      setXmameAsDefault.setEnabled(false);
      setXmameAsDefault.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          int n = model.getSize();
          for (int i = 0; i < n; i++) {
            ListItem li = (ListItem)model.getElementAt(i);
            int DEFAULT = li.getValue().indexOf(" (DEFAULT)");
	    if (DEFAULT > 0)
              model.setElementAt(new ListItem(Color.cyan,
	                                      li.getValue().substring(0,
	                                      DEFAULT).trim()), i);
          }

          ListItem item = (ListItem)model.getElementAt(
	                                      xmameExecList.getSelectedIndex());
	  model.setElementAt(new ListItem(Color.cyan, item.getValue() +
	                                  " (DEFAULT)"),
	                                  xmameExecList.getSelectedIndex());
	  removeXmameFromList.setEnabled(false);
	  setXmameAsDefault.setEnabled(false);
        }
      });
      buttonPanel.add(setXmameAsDefault);

      panel.add(buttonPanel);
      panel.add(Box.createVerticalStrut(10));

      // Use a list model that allows for updates
      model = new DefaultListModel();
      // Number of executables found
      int numberOfXmame = config.getInt("xmame.number_of_executable_files");

      if (numberOfXmame > 0) {
        dataio = new DataIO(romeo);
        // Paths to executables
        String[] xmameExecPaths = dataio.getXmamePaths();

	if (numberOfXmame == xmameExecPaths.length) {
          int DEFAULT = config.getInt("xmame.default_executable_file");

          for (int i = 0; i < numberOfXmame; i++) {
	    if (i == DEFAULT)
	      xmameExecPaths[i] = xmameExecPaths[i] + " (DEFAULT)";

	    ListItem li = new ListItem(Color.cyan, xmameExecPaths[i]);
	    model.addElement(li);
          }
	}
      }

      // Create a new JList
      xmameExecList = new JList(model);
      xmameExecList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      xmameExecList.setCellRenderer(new JListCellRenderer(
                                    utils.createImageIcon16x16("Exec.png")));
      // Add a mouse listener to the list
      xmameExecList.addMouseListener(new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
          int index = xmameExecList.locationToIndex(e.getPoint());
          ListItem item = (ListItem)model.getElementAt(index);
          Rectangle rect = xmameExecList.getCellBounds(index, index);
          xmameExecList.repaint(rect);

	  // Enable button to remove executable from the list
	  if (!removeXmameFromList.isEnabled())
	    removeXmameFromList.setEnabled(true);

	  int DEFAULT = item.getValue().indexOf(" (DEFAULT)");

	  if (DEFAULT > 0) {
	    if (setXmameAsDefault.isEnabled())
              setXmameAsDefault.setEnabled(false);
	  }
	  else {
	    if (!setXmameAsDefault.isEnabled())
              setXmameAsDefault.setEnabled(true);
	  }
        }
      });

      JScrollPane listScrollPane = new JScrollPane(xmameExecList);
      listScrollPane.getViewport().setView(xmameExecList);
      listScrollPane.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(listScrollPane);

      panel.add(listScrollPane);

      mamePanel.add(panel);

      xmameTabbedPane.addTab("xmame",
                             utils.createImageIcon16x16("Exec.png"),
			     mamePanel);

      // Action listener for buttons above
      ActionListener al = new OpenDirectory();
      // This class checks if a path is correct
      FocusListener fl = new CheckPaths();

      ImageIcon fileopen = utils.createImageIcon16x16("Fileopen.png");

      JTabbedPane dirsTabbedPane = new JTabbedPane();
      dirsTabbedPane.setTabPlacement(JTabbedPane.RIGHT);

      JPanel dirsPanel = new JPanel();
      dirsPanel.setLayout(new BoxLayout(dirsPanel, BoxLayout.Y_AXIS));
      dirsPanel.setBorder(BorderFactory.createTitledBorder(
                                              utils.getString("Settings.xmame_dirs")));

      panel = new JPanel();
      panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
      panel.setBorder(new EmptyBorder(10, 10, 10, 10));
      panel.setAlignmentX(LEFT_ALIGNMENT);

      JLabel romsLabel = new JLabel(utils.getString("Settings.roms_label"));
      romsLabel.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(romsLabel);
      panel.add(Box.createVerticalStrut(5));

      nPanel = new JPanel();
      nPanel.setLayout(new BoxLayout(nPanel, BoxLayout.X_AXIS));
      nPanel.setAlignmentX(LEFT_ALIGNMENT);

      // Field where to save rom paths in
      romField = new JTextField();
      romField.addFocusListener(fl);
      romField.setAlignmentX(LEFT_ALIGNMENT);
      romField.setMinimumSize(new Dimension(336, 24));
      romField.setPreferredSize(new Dimension(336, 24));
      romField.setMaximumSize(new Dimension(336, 24));
      nPanel.add(romField);
      nPanel.add(Box.createHorizontalStrut(10));

      romButton = new JButton();
      romButton.setAlignmentX(RIGHT_ALIGNMENT);
      romButton.setMinimumSize(new Dimension(24, 24));
      romButton.setPreferredSize(new Dimension(24, 24));
      romButton.setMaximumSize(new Dimension(24, 24));
      romButton.setIcon(fileopen);
      romButton.addActionListener(al);
      nPanel.add(romButton);

      panel.add(nPanel);
      panel.add(Box.createVerticalStrut(10));

      buttonPanel = new JPanel();
      buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
      buttonPanel.setAlignmentX(LEFT_ALIGNMENT);

      addRomDirToList = new JButton(utils.getString(
                                              "Settings.xmame_add_executable"));
      addRomDirToList.setAlignmentX(LEFT_ALIGNMENT);
      addRomDirToList.setMinimumSize(new Dimension(180, 30));
      addRomDirToList.setPreferredSize(new Dimension(180, 30));
      addRomDirToList.setMaximumSize(new Dimension(180, 30));
      addRomDirToList.setIcon(utils.createImageIcon16x16("Add.png"));
      addRomDirToList.setEnabled(false);
      addRomDirToList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  String s = romField.getText();
	  // Check if the dir has already been added to the list
	  int added = 0;
	  Object[] romDirs = model2.toArray();
	  String path;
	  if (romDirs.length > 0) {
	    for (int i = 0; i < romDirs.length; i++) {
	      ListItem item = (ListItem)model2.getElementAt(i);

	      path = item.getValue().toString();

	      if (path.equals(s)) {
	        added = 1;
	        break;
	      }
	    }
	  }

          if (added == 0) {
	    // Add the executable to the list
	    ListItem li = new ListItem(Color.cyan, s);
	    model2.addElement(li);
	    romField.setText("");
	    addRomDirToList.setEnabled(false);
	  }
	  else if (added == 1) {
	    JOptionPane.showMessageDialog(null, utils.getString(
	                                  "Messagebox.xmame_already_added"),
                                          utils.getString("Messagebox.error_title"),
                                          JOptionPane.ERROR_MESSAGE);
	    romField.setText("");
	    addRomDirToList.setEnabled(false);
	  }
	}
      });
      buttonPanel.add(addRomDirToList);
      buttonPanel.add(Box.createHorizontalStrut(10));

      // This button removes an item from the list
      removeRomDirFromList = new JButton(utils.getString(
                                           "Settings.xmame_remove_executable"));
      removeRomDirFromList.setAlignmentX(RIGHT_ALIGNMENT);
      removeRomDirFromList.setMinimumSize(new Dimension(180, 30));
      removeRomDirFromList.setPreferredSize(new Dimension(180, 30));
      removeRomDirFromList.setMaximumSize(new Dimension(180, 30));
      removeRomDirFromList.setIcon(utils.createImageIcon16x16("Add.png"));
      removeRomDirFromList.setIcon(utils.createImageIcon16x16("Remove.png"));
      removeRomDirFromList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
	  // Remove selected dir from the list
	  model2.removeElementAt(romDirList.getSelectedIndex());
	  removeRomDirFromList.setEnabled(false);
	}
      });
      removeRomDirFromList.setEnabled(false);
      buttonPanel.add(removeRomDirFromList);

      panel.add(buttonPanel);
      panel.add(Box.createVerticalStrut(10));

      // Use a list model that allows for updates
      model2 = new DefaultListModel();
      // Number of executables found
      int numberOfRomDirs = config.getInt("xmame.number_of_rom_dirs");

      if (numberOfRomDirs > 0) {
        String[] romDirPaths = utils.parseValues(config.get("xmame.rom_dir"), ';');

        if (numberOfRomDirs == romDirPaths.length) {
	  File dir = null;

	  for (int i = 0; i < numberOfRomDirs; i++) {
            dir = new File(romDirPaths[i]);
	    if (dir.exists()) {
	      ListItem li = new ListItem(Color.cyan, romDirPaths[i]);
	      model2.addElement(li);
	    }
          }
	}
      }

      // Create a new JList
      romDirList = new JList(model2);
      romDirList.setAlignmentX(LEFT_ALIGNMENT);
      romDirList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      romDirList.setCellRenderer(new JListCellRenderer(
                                    utils.createImageIcon16x16("Folder.png")));
      // Add a mouse listener to the list
      romDirList.addMouseListener(new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
          int index = romDirList.locationToIndex(e.getPoint());
          ListItem item = (ListItem)model2.getElementAt(index);
          Rectangle rect = romDirList.getCellBounds(index, index);
          romDirList.repaint(rect);

	  // Enable button to remove executable from the list
	  if (!removeRomDirFromList.isEnabled())
	    removeRomDirFromList.setEnabled(true);
        }
      });

      listScrollPane = new JScrollPane(romDirList);
      listScrollPane.getViewport().setView(romDirList);
      listScrollPane.setAlignmentX(LEFT_ALIGNMENT);
      panel.add(listScrollPane);

      dirsPanel.add(panel);

      dirsTabbedPane.addTab("(1)",
                            utils.createImageIcon16x16("Folder.png"),
			    dirsPanel);

      dirsPanel = new JPanel(new GridLayout(7, 1));
      dirsPanel.setBorder(BorderFactory.createTitledBorder(
                                              utils.getString("Settings.xmame_dirs")));

      JPanel p = new JPanel(new BorderLayout());

      JLabel snapLabel = new JLabel(utils.getString("Settings.snap_label"));
      p.add(snapLabel, BorderLayout.NORTH);

      // Snaps dir
      snapField = new JTextField(config.get("xmame.snap_dir"));
      snapField.addFocusListener(fl);
      p.add(snapField, BorderLayout.CENTER);

      snapButton = new JButton();
      snapButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      snapButton.setIcon(fileopen);
      snapButton.addActionListener(al);
      p.add(snapButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel flyersLabel = new JLabel(utils.getString("Settings.flyers_label"));
      p.add(flyersLabel, BorderLayout.NORTH);

      // Flyers dir
      flyerField = new JTextField(config.get("xmame.flyer_dir"));
      flyerField.addFocusListener(fl);
      p.add(flyerField, BorderLayout.CENTER);

      flyerButton = new JButton();
      flyerButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      flyerButton.setIcon(fileopen);
      flyerButton.addActionListener(al);
      p.add(flyerButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel marqueesLabel = new JLabel(utils.getString("Settings.marquees_label"));
      p.add(marqueesLabel, BorderLayout.NORTH);

      // Marquees dir
      marqueeField = new JTextField(config.get("xmame.marquee_dir"));
      marqueeField.addFocusListener(fl);
      p.add(marqueeField, BorderLayout.CENTER);

      marqueeButton = new JButton();
      marqueeButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      marqueeButton.setIcon(fileopen);
      marqueeButton.addActionListener(al);
      p.add(marqueeButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel cabinetsLabel = new JLabel(utils.getString("Settings.cabinets_label"));
      p.add(cabinetsLabel, BorderLayout.NORTH);

      // Cabinet photos dir
      cabinetField = new JTextField(config.get("xmame.cabinet_dir"));
      cabinetField.addFocusListener(fl);
      p.add(cabinetField, BorderLayout.CENTER);

      cabinetButton = new JButton();
      cabinetButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      cabinetButton.setIcon(fileopen);
      cabinetButton.addActionListener(al);
      p.add(cabinetButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel samplesLabel = new JLabel(utils.getString("Settings.samples_label"));
      p.add(samplesLabel, BorderLayout.NORTH);

      // Audio samples dir
      sampleField = new JTextField(config.get("xmame.sample_dir"));
      sampleField.addFocusListener(fl);
      p.add(sampleField, BorderLayout.CENTER);

      sampleButton = new JButton();
      sampleButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      sampleButton.setIcon(fileopen);
      sampleButton.addActionListener(al);
      p.add(sampleButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel artworksLabel = new JLabel(utils.getString("Settings.artworks_label"));
      p.add(artworksLabel, BorderLayout.NORTH);

      // Artworks dir
      artworkField = new JTextField(config.get("xmame.artwork_dir"));
      artworkField.addFocusListener(fl);
      p.add(artworkField, BorderLayout.CENTER);

      artworkButton = new JButton();
      artworkButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      artworkButton.setIcon(fileopen);
      artworkButton.addActionListener(al);
      p.add(artworkButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel iniLabel = new JLabel(utils.getString("Settings.ini_label"));
      p.add(iniLabel, BorderLayout.NORTH);

      // Field where to save ini files in
      iniField = new JTextField(config.get("xmame.ini_dir"));
      iniField.addFocusListener(fl);
      p.add(iniField, BorderLayout.CENTER);

      iniButton = new JButton();
      iniButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      iniButton.setIcon(fileopen);
      iniButton.addActionListener(al);
      p.add(iniButton, BorderLayout.EAST);

      dirsPanel.add(p);



      dirsTabbedPane.addTab("(2)",
                            utils.createImageIcon16x16("Folder.png"),
			    dirsPanel);

      dirsPanel = new JPanel(new GridLayout(7, 1));
      dirsPanel.setBorder(BorderFactory.createTitledBorder(
                                              utils.getString("Settings.xmame_dirs")));

      p = new JPanel(new BorderLayout());

      JLabel cfgLabel = new JLabel(utils.getString("Settings.cfg_label"));
      p.add(cfgLabel, BorderLayout.NORTH);

      // cfg dir
      cfgField = new JTextField(config.get("xmame.cfg_dir"));
      cfgField.addFocusListener(fl);
      p.add(cfgField, BorderLayout.CENTER);

      cfgButton = new JButton();
      cfgButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      cfgButton.setIcon(fileopen);
      cfgButton.addActionListener(al);
      p.add(cfgButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel nvramLabel = new JLabel(utils.getString("Settings.nvram_label"));
      p.add(nvramLabel, BorderLayout.NORTH);

      // nvram dir
      nvramField = new JTextField(config.get("xmame.nvram_dir"));
      nvramField.addFocusListener(fl);
      p.add(nvramField, BorderLayout.CENTER);

      nvramButton = new JButton();
      nvramButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      nvramButton.setIcon(fileopen);
      nvramButton.addActionListener(al);
      p.add(nvramButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel memcardLabel = new JLabel(utils.getString("Settings.memcard_label"));
      p.add(memcardLabel, BorderLayout.NORTH);

      // memcard dir
      memcardField = new JTextField(config.get("xmame.memcard_dir"));
      memcardField.addFocusListener(fl);
      p.add(memcardField, BorderLayout.CENTER);

      memcardButton = new JButton();
      memcardButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      memcardButton.setIcon(fileopen);
      memcardButton.addActionListener(al);
      p.add(memcardButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel inputLabel = new JLabel(utils.getString("Settings.input_label"));
      p.add(inputLabel, BorderLayout.NORTH);

      // input dir
      inputField = new JTextField(config.get("xmame.input_dir"));
      inputField.addFocusListener(fl);
      p.add(inputField, BorderLayout.CENTER);

      inputButton = new JButton();
      inputButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      inputButton.setIcon(fileopen);
      inputButton.addActionListener(al);
      p.add(inputButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel stateLabel = new JLabel(utils.getString("Settings.state_label"));
      p.add(stateLabel, BorderLayout.NORTH);

      stateField = new JTextField(config.get("xmame.state_dir"));
      stateField.addFocusListener(fl);
      p.add(stateField, BorderLayout.CENTER);

      stateButton = new JButton();
      stateButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      stateButton.setIcon(fileopen);
      stateButton.addActionListener(al);
      p.add(stateButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel diffLabel = new JLabel(utils.getString("Settings.diff_label"));
      p.add(diffLabel, BorderLayout.NORTH);

      diffField = new JTextField(config.get("xmame.diff_dir"));
      diffField.addFocusListener(fl);
      p.add(diffField, BorderLayout.CENTER);

      diffButton = new JButton();
      diffButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      diffButton.setIcon(fileopen);
      diffButton.addActionListener(al);
      p.add(diffButton, BorderLayout.EAST);

      dirsPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel ctrlrLabel = new JLabel(utils.getString("Settings.ctrlr_label"));
      p.add(ctrlrLabel, BorderLayout.NORTH);

      ctrlrField = new JTextField(config.get("xmame.ctrlr_dir"));
      ctrlrField.addFocusListener(fl);
      p.add(ctrlrField, BorderLayout.CENTER);

      ctrlrButton = new JButton();
      ctrlrButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      ctrlrButton.setIcon(fileopen);
      ctrlrButton.addActionListener(al);
      p.add(ctrlrButton, BorderLayout.EAST);

      dirsPanel.add(p);

      dirsTabbedPane.addTab("(3)",
                            utils.createImageIcon16x16("Folder.png"),
			    dirsPanel);

      xmameTabbedPane.addTab(utils.getString("Settings.xmame_dirs"),
                             utils.createImageIcon16x16("Folder.png"),
			     dirsTabbedPane);
			     
      //****** Panel for other xmame files
      JPanel xmameFilesPanel = new JPanel(new GridLayout(7, 1));
      xmameFilesPanel.setBorder(BorderFactory.createTitledBorder(
                                              utils.getString("Settings.xmame_files")));
      
      ImageIcon text = utils.createImageIcon16x16("Text.png");

      p = new JPanel(new BorderLayout());

      JLabel cheatLabel = new JLabel(utils.getString("Settings.cheat.dat_label"));
      p.add(cheatLabel, BorderLayout.NORTH);

      cheatField = new JTextField(config.get("xmame.cheat.dat_path"));
      p.add(cheatField, BorderLayout.CENTER);

      cheatButton = new JButton();
      cheatButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      cheatButton.setIcon(fileopen);
      cheatButton.addActionListener(new openDatFiles());
      p.add(cheatButton, BorderLayout.EAST);

      xmameFilesPanel.add(p);

      p = new JPanel(new BorderLayout());

      JLabel hiscoreLabel = new JLabel(utils.getString("Settings.hiscore.dat_label"));
      p.add(hiscoreLabel, BorderLayout.NORTH);

      hiscoreField = new JTextField(config.get("xmame.hiscore.dat_path"));
      p.add(hiscoreField, BorderLayout.CENTER);

      hiscoreButton = new JButton();
      hiscoreButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      hiscoreButton.setIcon(fileopen);
      hiscoreButton.addActionListener(new openDatFiles());
      p.add(hiscoreButton, BorderLayout.EAST);

      xmameFilesPanel.add(p);
      
      p = new JPanel(new BorderLayout());

      JLabel historyLabel = new JLabel(utils.getString("Settings.history.dat_label"));
      p.add(historyLabel, BorderLayout.NORTH);

      historyField = new JTextField(config.get("xmame.history.dat_path"));
      p.add(historyField, BorderLayout.CENTER);

      historyButton = new JButton();
      historyButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      historyButton.setIcon(fileopen);
      historyButton.addActionListener(new openDatFiles());
      p.add(historyButton, BorderLayout.EAST);

      xmameFilesPanel.add(p);
      
      p = new JPanel(new BorderLayout());

      JLabel mameinfoLabel = new JLabel(utils.getString("Settings.mameinfo.dat_label"));
      p.add(mameinfoLabel, BorderLayout.NORTH);

      mameinfoField = new JTextField(config.get("xmame.mameinfo.dat_path"));
      p.add(mameinfoField, BorderLayout.CENTER);

      mameinfoButton = new JButton();
      mameinfoButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      mameinfoButton.setIcon(fileopen);
      mameinfoButton.addActionListener(new openDatFiles());
      p.add(mameinfoButton, BorderLayout.EAST);

      xmameFilesPanel.add(p);
      
      p = new JPanel(new BorderLayout());

      JLabel catverLabel = new JLabel(utils.getString("Settings.catver.ini_label"));
      p.add(catverLabel, BorderLayout.NORTH);

      catverField = new JTextField(config.get("xmame.catver.ini_path"));
      p.add(catverField, BorderLayout.CENTER);

      catverButton = new JButton();
      catverButton.setBorder(new EmptyBorder(5, 5, 5, 5));
      catverButton.setIcon(fileopen);
      catverButton.addActionListener(new openCatverFile());
      p.add(catverButton, BorderLayout.EAST);

      xmameFilesPanel.add(p);

      xmameFilesPanel.add(new JLabel());
      xmameFilesPanel.add(new JLabel());

      xmameTabbedPane.addTab(utils.getString("Settings.xmame_files"),
                             utils.createImageIcon16x16("Misc.png"),
			     xmameFilesPanel);

      add(xmameTabbedPane, BorderLayout.CENTER);
      
      add(new DialogSeparator(), BorderLayout.SOUTH);
    }
    
    /**
     * FileChooser to set xmame path.
     */
    public class OpenXmameExecutable implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        filechooser = new JFileChooser();
        int returnVal = filechooser.showOpenDialog(XmameSettings.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
          xmameField.setText(filechooser.getSelectedFile().getPath());

	  if (!addXmameToList.isEnabled())
	    addXmameToList.setEnabled(true);
        }
      }
    }
    
    /**
     * FileChooser to select dirs.
     */
    public class OpenDirectory implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        JButton b = (JButton) e.getSource();

        filechooser = new JFileChooser();
        filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = filechooser.showOpenDialog(XmameSettings.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
          if (b == romButton) {
            romField.setText(filechooser.getSelectedFile().getPath() +
	                      File.separator);
            addRomDirToList.setEnabled(true);
	  }
	  else if (b == snapButton)
            snapField.setText(filechooser.getSelectedFile().getPath() +
	                      File.separator);
	  else if (b == flyerButton)
            flyerField.setText(filechooser.getSelectedFile().getPath() +
	                        File.separator);
	  else if (b == marqueeButton)
            marqueeField.setText(filechooser.getSelectedFile().getPath() +
	                          File.separator);
	  else if (b == cabinetButton)
            cabinetField.setText(filechooser.getSelectedFile().getPath() +
	                          File.separator);
          else if (b == sampleButton)
            sampleField.setText(filechooser.getSelectedFile().getPath() +
	                         File.separator);
          else if (b == artworkButton)
            artworkField.setText(filechooser.getSelectedFile().getPath() +
	                          File.separator);
          else if (b == iniButton)
            iniField.setText(filechooser.getSelectedFile().getPath() +
	                     File.separator);
          else if (b == cfgButton)
            cfgField.setText(filechooser.getSelectedFile().getPath() +
	                     File.separator);
          else if (b == nvramButton)
            nvramField.setText(filechooser.getSelectedFile().getPath() +
	                       File.separator);
          else if (b == memcardButton)
            memcardField.setText(filechooser.getSelectedFile().getPath() +
	                         File.separator);
          else if (b == inputButton)
            inputField.setText(filechooser.getSelectedFile().getPath() +
	                       File.separator);
          else if (b == stateButton)
            stateField.setText(filechooser.getSelectedFile().getPath() +
	                       File.separator);
	  else if (b == diffButton)
            diffField.setText(filechooser.getSelectedFile().getPath() +
	                      File.separator);
          else if (b == ctrlrButton)
            ctrlrField.setText(filechooser.getSelectedFile().getPath() +
	                       File.separator);
        }
      }
    }

    /**
     * This class checks if dir path are correct.
     */
    public class CheckPaths implements FocusListener {
      public void focusLost(FocusEvent e) {
        JTextField textField = (JTextField)e.getSource();
        String content = textField.getText();
        if (content.length() != 0) {
	  File dir = new File(content);
	  if (dir.exists()) {
            if (!content.endsWith(File.separator))
	      textField.setText(content + File.separator);
	  }
	  else {
	    getToolkit().beep();
	    textField.setText("");
	    textField.requestFocus();
	  }
        }
      }
      public void focusGained(FocusEvent e) {
        // to handle
      }
    }
    
    /**
     * FileChooser for files with extension '.dat'.
     */
    class openDatFiles implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        JButton b = (JButton) e.getSource();

        filechooser2 = new JFileChooser();
        filechooser2.setFileFilter(new fileFilter());
        int returnVal = filechooser2.showOpenDialog(XmameSettings.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
	  if (b == cheatButton) {
            cheatField.setText(filechooser2.getSelectedFile().getPath());
	  }
	  else if (b == hiscoreButton) {
            hiscoreField.setText(filechooser2.getSelectedFile().getPath());
	  }
	  else if (b == historyButton) {
            historyField.setText(filechooser2.getSelectedFile().getPath());
	    romeo.info.historyField.setText(
	                         filechooser2.getSelectedFile().getPath());
	  }
	  else if (b == mameinfoButton) {
            mameinfoField.setText(filechooser2.getSelectedFile().getPath());
	  }
        }
      }
    }

    /**
     * Filter for <files>.dat
     */
    class fileFilter extends FileFilter {
      public boolean accept(File f) {
        if (f.isDirectory())
          return true;
        String path = f.getPath().toLowerCase();
        if (path.endsWith(".dat"))
          return true;
        return false;
      }
      // Return a file description
      public String getDescription() {
        return "File (*.dat)";
      }
    }

    /**
     * FileChooser for catver.ini.
     */
    class openCatverFile implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        JButton b = (JButton) e.getSource();

        filechooser2 = new JFileChooser();
        filechooser2.setFileFilter(new catverFilter());
        int returnVal = filechooser2.showOpenDialog(XmameSettings.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
	  catverField.setText(filechooser2.getSelectedFile().getPath());
        }
      }
    }

    /**
     * Filter for files ".dat".
     */
    class catverFilter extends FileFilter {
      public boolean accept(File f) {
        if (f.isDirectory())
          return true;
        String path = f.getPath().toLowerCase();
        if (path.endsWith(".ini"))
          return true;
        return false;
      }
      // Return a file description
      public String getDescription() {
        return "File Catver (catver.ini)";
      }
    }
  }

  /**
   * Panel for data storing options.
   */
  class DataStoringSettings extends JPanel {

    public DataStoringSettings() {
      setLayout(new BorderLayout());
      setBorder(new EmptyBorder(10, 10, 10, 10));

      JPanel northPanel = new JPanel(new BorderLayout());

      JLabel infoLabel = new JLabel(info4);
      infoLabel.setFont(getFont().deriveFont(1, 12));
      northPanel.add(infoLabel, BorderLayout.NORTH);

      ds = new DialogSeparator();
      northPanel.add(ds, BorderLayout.SOUTH);

      add(northPanel, BorderLayout.NORTH);

      JPanel centerPanel = new JPanel(new BorderLayout());
      JLabel labelStoring = new JLabel(utils.getString("Settings.data_storing_label"));
      labelStoring.setBorder(new EmptyBorder(5, 5, 5, 5));
      centerPanel.add(labelStoring, BorderLayout.NORTH);

      /*
      JPanel p = new JPanel();
      p.setLayout(new GridLayout(3, 1));
      p.setBorder(new EmptyBorder(10, 10, 10, 10));
      */

      ButtonGroup group = new ButtonGroup();

      /*
      aP0 = new APanel(group, "XML (recommended)", utils.getString("Settings.data_xml"), 1);
      p.add(aP0);
      aP1 = new APanel(group, "MySQL (EXPERIMENTAL)", utils.getString("Settings.data_sql"), 2);
      p.add(aP1);
      aP2 = new APanel(group, "Text (deprecated)", utils.getString("Settings.data_txt"), 3);
      p.add(aP2);
      */

      int aPSelected = config.getInt("data_storing_type");

      /*
      switch (aPSelected) {
        case 0:
          aP0.getRadioButton().setSelected(true);
          break;
        case 1:
          aP1.getRadioButton().setSelected(true);
          break;
        case 2:
          aP2.getRadioButton().setSelected(true);
          break;
        default:
	  aP0.getRadioButton().setSelected(true);
          break;
      }
      */

      JPanel p = new JPanel();
      p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
      p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));

      // options
      xmlButton = new JRadioButton();
      xmlButton.setText(utils.getString("Settings.data_xml"));
      group.add(xmlButton);
      xmlButton.setAlignmentX(LEFT_ALIGNMENT);
      p.add(xmlButton);
      panel.add(Box.createVerticalStrut(10));

      sqlButton = new JRadioButton();
      sqlButton.setText(utils.getString("Settings.data_sql"));
      group.add(sqlButton);
      sqlButton.setAlignmentX(LEFT_ALIGNMENT);
      p.add(sqlButton);
      panel.add(Box.createVerticalStrut(10));

      txtButton = new JRadioButton();
      txtButton.setText(utils.getString("Settings.data_txt"));
      group.add(txtButton);
      txtButton.setAlignmentX(LEFT_ALIGNMENT);
      p.add(txtButton);

      switch (aPSelected) {
        case 0:
          xmlButton.setSelected(true);
          break;
        case 1:
          sqlButton.setSelected(true);
          break;
        case 2:
          txtButton.setSelected(true);
          break;
        default:
	  xmlButton.setSelected(true);
          break;
      }

      centerPanel.add(p, BorderLayout.CENTER);

      JPanel mysqlPanel = new JPanel(new BorderLayout());

      JLabel label = new JLabel(utils.getString("Settings.mysql_warning"));
      label.setBorder(new EmptyBorder(5, 5, 5, 5));
      mysqlPanel.add(label, BorderLayout.NORTH);

      p = new JPanel(new GridLayout(10, 1));
      p.setBorder(new EmptyBorder(5, 5, 5, 5));

      label = new JLabel(utils.getString("Settings.mysql_username"));
      p.add(label);
      mysqlUser = new JTextField(config.get("mysql.user"));
      p.add(mysqlUser);

      label = new JLabel(utils.getString("Settings.mysql_password"));
      p.add(label);
      mysqlPasswd = new JPasswordField(config.get("mysql.passwd"));
      Font echoCharFont = new Font("Lucida Sans", Font.PLAIN, 12);
      mysqlPasswd.setFont(echoCharFont);
      mysqlPasswd.setEchoChar('\u2022');
      p.add(mysqlPasswd);

      label = new JLabel(utils.getString("Settings.mysql_hostname"));
      p.add(label);
      mysqlHostname = new JTextField(config.get("mysql.hostname"));
      p.add(mysqlHostname);

      p.add(new JLabel());
      p.add(new JLabel());
      p.add(new JLabel());
      p.add(new JLabel());

      mysqlPanel.add(p, BorderLayout.CENTER);

      tPane = new JTabbedPane();
      tPane.addTab(info4, null, centerPanel);
      tPane.addTab("MySQL", null, mysqlPanel);

      add(tPane, BorderLayout.CENTER);

      add(new DialogSeparator(), BorderLayout.SOUTH);
    }
  }

  /*
  class APanel extends CompTitledPane {
    JRadioButton titleComp;

    APanel(ButtonGroup group, String text, String info, final int type) {
      titleComp = new JRadioButton(text);
      JLabel label = new JLabel(info);
      label.setPreferredSize(new Dimension(375, 50));
      setTitleComponent(titleComp);
      this.titleComp = titleComp;
      group.add(titleComp);
      //titleComp.setSelected(true);
      titleComp.addItemListener(new ItemListener() {
        public void itemStateChanged(ItemEvent e) {
          //if (type == 2)
          //tPane.getComponentAt(1).setEnabled(e.getStateChange() == ItemEvent.SELECTED);
        }
      });
      getContentPane().add(label);
    }

    public JRadioButton getRadioButton() {
      return titleComp;
    }
  }
  */

  /**
   * Panel that holds Internet settings.
   */
  class InternetSettings extends JPanel {

    public InternetSettings() {
      setLayout(new BorderLayout());
      setBorder(new EmptyBorder(10, 10, 10, 10));

      JPanel northPanel = new JPanel(new BorderLayout());

      JLabel infoLabel = new JLabel(info5);
      infoLabel.setFont(getFont().deriveFont(1, 12));
      northPanel.add(infoLabel, BorderLayout.NORTH);

      ds = new DialogSeparator();
      northPanel.add(ds, BorderLayout.SOUTH);

      add(northPanel, BorderLayout.NORTH);

      JPanel panel = new JPanel(new BorderLayout());

      JPanel you = new JPanel(new GridLayout(3, 1));
      you.setBorder(BorderFactory.createTitledBorder(
                                             utils.getString("Settings.internet_you")));

      JPanel p = new JPanel(new BorderLayout());

      JLabel nameLabel = new JLabel(utils.getString("Settings.internet_name_label"));
      p.add(nameLabel, BorderLayout.NORTH);

      nameField = new JTextField(config.get("User.name"));
      p.add(nameField, BorderLayout.CENTER);

      you.add(p);

      p = new JPanel(new BorderLayout());

      JPanel p2 = new JPanel(new GridLayout(1, 2));

      JPanel p3 = new JPanel(new BorderLayout());

      JLabel mailLabel = new JLabel(
                              utils.getString("Settings.internet_mail_label"));
      p3.add(mailLabel, BorderLayout.NORTH);

      mailField = new JTextField(config.get("User.mail"));
      p3.add(mailField, BorderLayout.CENTER);

      p2.add(p3);

      JPanel p4 = new JPanel(new BorderLayout());

      JLabel smtpLabel = new JLabel(
                              utils.getString("Settings.internet_smtp_label"));
      p4.add(smtpLabel, BorderLayout.NORTH);

      smtpField = new JTextField(config.get("User.smtp"));
      p4.add(smtpField, BorderLayout.CENTER);

      p2.add(p4);

      p.add(p2, BorderLayout.CENTER);

      you.add(p);

      p = new JPanel(new BorderLayout());

      JLabel browserLabel = new JLabel(utils.getString(
                                                    "Settings.internet_browser_label"));
      p.add(browserLabel, BorderLayout.NORTH);

      browserField = new JTextField(config.get("User.browser"));
      p.add(browserField, BorderLayout.CENTER);

      JButton browser = new JButton();
      browser.setBorder(new EmptyBorder(5, 5, 5, 5));
      browser.setIcon(utils.createImageIcon16x16("Exec.png"));
      browser.addActionListener(new openBrowserExecutable());
      p.add(browser, BorderLayout.EAST);

      you.add(p);

      panel.add(you, BorderLayout.NORTH);

      JPanel me = new JPanel(new GridLayout(4, 1));
      me.setBorder(BorderFactory.createTitledBorder(
                                              utils.getString("Settings.internet_me")));

      p = new JPanel(new BorderLayout());

      JLabel downRomsLabel = new JLabel(utils.getString(
                                                     "Settings.internet_downroms_label"));
      p.add(downRomsLabel, BorderLayout.NORTH);

      downRomsField = new JTextField(config.get("xmame.rom_server"));
      p.add(downRomsField, BorderLayout.CENTER);

      me.add(p);

      p = new JPanel(new BorderLayout());

      JLabel downImagesLabel = new JLabel(utils.getString(
                                           "Settings.internet_downimg_label"));
      p.add(downImagesLabel, BorderLayout.NORTH);

      String[] imageTypes = {" snaps", " flyers", " marquees", " cabinets"};

      imageType = new JComboBox(imageTypes);
      imageType.setRenderer(new ComboBoxRenderer(imageType, utils.createImageIcon16x16("Image.png")));
      imageType.addActionListener(new setImagesServer());
      p.add(imageType, BorderLayout.WEST);

      String[] servers = {" " + config.get("xmame.snap_server"),
                          " " + config.get("xmame.flyer_server"),
			  " " + config.get("xmame.marquee_server"),
			  " " + config.get("xmame.cabinet_server")};

      for (int i = 0; i < servers.length; i++) {
        if (servers[i].equals("") || servers[i].equals(" null"))
	  servers[i] = " " + i + ")";
      }

      server = new EditableComboBox(servers);
      server.addActionListener(new setImageType());
      p.add(server, BorderLayout.CENTER);

      me.add(p);

      p = new JPanel(new BorderLayout());

      JLabel downSampleLabel = new JLabel(utils.getString(
                                          "Settings.internet_downsample_label"));
      p.add(downSampleLabel, BorderLayout.NORTH);

      downSampleField = new JTextField(config.get("xmame.sample_server"));
      p.add(downSampleField, BorderLayout.CENTER);

      me.add(p);
      
      p = new JPanel(new BorderLayout());

      JLabel downArtworkLabel = new JLabel(utils.getString(
                                        "Settings.internet_downartwork_label"));
      p.add(downArtworkLabel, BorderLayout.NORTH);

      downArtworkField = new JTextField(config.get("xmame.artwork_server"));
      p.add(downArtworkField, BorderLayout.CENTER);

      me.add(p);

      panel.add(me, BorderLayout.CENTER);

      add(panel, BorderLayout.CENTER);

      add(new DialogSeparator(), BorderLayout.SOUTH);
    }

    public class openBrowserExecutable implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        filechooser = new JFileChooser();
        int returnVal = filechooser.showOpenDialog(InternetSettings.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
          browserField.setText(filechooser.getSelectedFile().getPath());
        }
      }
    }
    
    public class setImagesServer implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        String file_type = (String)imageType.getSelectedItem();

	if (file_type.equals(" snaps"))
	  server.setSelectedIndex(0);
	else if (file_type.equals(" flyers"))
	  server.setSelectedIndex(1);
	else if (file_type.equals(" marquees"))
	  server.setSelectedIndex(2);
	else if (file_type.equals(" cabinets"))
	  server.setSelectedIndex(3);
      }
    }

    public class setImageType implements ActionListener {
      public void actionPerformed(ActionEvent e) {
        int i = (int)server.getSelectedIndex();

	if (i == 0)
	  imageType.setSelectedIndex(0);
	else if (i == 1)
	  imageType.setSelectedIndex(1);
	else if (i == 2)
	  imageType.setSelectedIndex(2);
	else if (i == 3)
	  imageType.setSelectedIndex(3);
      }
    }
  }
    
  /**
   * Editable JComboBox for image servers.
   */
  public class EditableComboBox extends JComboBox implements KeyListener,
                                                             MouseListener {
    private JPopupMenu popupMenu;
    private JTextField editor;

    public EditableComboBox() {
      super();

      setEditable(true);
      setToolTipText("<html><center><font color=blue>" +
                     utils.getString("Settings.internet_downimg_tooltiptext") +
		     "</font></center></html>");
      editor = (JTextField)getEditor().getEditorComponent();
      editor.addKeyListener(this);
      editor.addMouseListener(this);

      popupMenu = new JPopupMenu();
      add(popupMenu);

      popupMenu.add(new RemoveAction());
    }

    public EditableComboBox(Object items[]) {
      super(items);

      setEditable(true);
      setToolTipText("<html><center><font color=blue>" +
                     utils.getString("Settings.internet_downimg_tooltiptext") +
		     "</font></center></html>");
      editor = (JTextField)getEditor().getEditorComponent();
      editor.addKeyListener(this);
      editor.addMouseListener(this);

      popupMenu = new JPopupMenu();
      add(popupMenu);

      popupMenu.add(new RemoveAction());
    }

    public void addItem(Object object) {
      insertItemAt(object, imageType.getSelectedIndex());
    }


    public void setModel()throws Exception {
      throw new Exception("Can' t set Model in EditableComboBox");
    }

    public void addEditingItem() {
      insertItemAt(editor.getText().toString(), imageType.getSelectedIndex());
    }

    public void insertItemAt(Object object,int index) {//throws Exception
      int k = 0;
      boolean unique = true;
      while(k < getItemCount()) {
        Object s = getItemAt(k);
        if(s.equals(object)) {
          unique = false;
          k = getItemCount();
        }
        else
          k++;
      }

      if(unique && object.toString().trim().length() > 0) {
        super.insertItemAt(object, index);
	super.removeItemAt(index + 1);
      }
    }

    // An Action needed for the PopupMenu
    class RemoveAction extends AbstractAction {
       public RemoveAction() {
         super("Remove");
       }

       public void actionPerformed(ActionEvent evt) {
         removeItemAt(getSelectedIndex());
       }
     }

     // Method to satisfy KeyListener Interface
     public void keyPressed(KeyEvent e) {
       if (e.getKeyCode()== KeyEvent.VK_ENTER) {
         insertItemAt(editor.getText().toString(),
	              imageType.getSelectedIndex());
         setSelectedIndex(imageType.getSelectedIndex());
       }
     }

     // Method to satisfy KeyListener Interface
     public void keyReleased(KeyEvent e) {
     }

     // Method to satisfy KeyListener Interface
     public void keyTyped(KeyEvent e) {
     }

     // Method to satisfy MouseListener Interface
     public void mouseClicked(MouseEvent e) {
     }

     // Method to satisfy MouseListener Interface
     public void mouseEntered(MouseEvent e) {
     }

     // Method to satisfy MouseListener Interface
     public void mouseExited(MouseEvent e) {
     }

     // Method to satisfy MouseListener Interface
     public void mousePressed(MouseEvent e) {
     }

     // Method to satisfy MouseListener Interface
     public void mouseReleased(MouseEvent e) {
      if (e.isPopupTrigger()) {
        int x = e.getX();
        int y = e.getY();

        popupMenu.show(this, x, y);
      }
    }
  }
  
  /**
   * This class saves the configuration file.
   */
  public class SaveAction implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      // Path to configuration file
      String config_name = System.getProperty("user.home") +
                           File.separator + ".romeo4xmame" +
			   File.separator + "Romeo.ini";
      // Configuration file
      File config_file = new File(config_name);
      // Class to read and write the configurations
      Config config = new Config(config_file);

      //****** Save splash screen option
      config.add("Show_splashscreen", showSplashScreenBox.isSelected());

      //****** Save ' load list of games ' option
      config.add("Load_list_of_games", loadListOfGamesBox.isSelected());

      config.add("Load_choosen_list", chooseListBox.getSelectedIndex());

      //****** Save ' check new release ' option
      config.add("Romeo.New_Release", newReleaseBox.isSelected());

      //****** Save ' windows iconified ' option
      if (iconifyWindowsBox.isSelected())
        config.add("Iconify_before_playing", true);
      else
        config.add("Iconify_before_playing", false);

      //****** Save selected language
      String lan = languageComboBox.getSelectedItem().toString().trim();

      if (lan.equals(" No file available")) {
        config.add("Language", "English");
	config.add("Language.index", 0);
      }
      else {
        config.add("Language", lan);
	config.add("Language.index", languageComboBox.getSelectedIndex());
      }

      //****** Save skin options
      if (skinCheckBox.isSelected()) {
	if (useSkin.isSelected()&&
            !skinBox.getSelectedItem().toString().equals(
	                                          " No skin available")) {
          config.add("Use_skin", true);
          config.add("Skin.index", skinBox.getSelectedIndex());
          config.add("Skin.path", "skins" + File.separator +
                     skinBox.getSelectedItem().toString().trim());
        }
      }
      else {
        config.add("Use_skin", false);
	config.add("Skin.index", -1);
        config.add("Skin.path", "");
      }

      //****** Save icon options
      config.add("Use_iconset", chooseIconSetBox.getSelectedIndex());

      //****** Save look options
      config.add("Table.intercell_spacing", interCellSpacingSlider.getValue());
      config.add("Table.row_height", rowHeightSlider.getValue());

      config.add("Tables.show_options", showControls.isSelected());

      Object[] xmameExec = model.toArray();
      String[] path = null;
      /*int defaultXmame = 0;*/

      if (xmameExec.length > 0) {
        path = new String[xmameExec.length];

        for (int i = 0; i < xmameExec.length; i++) {
	  ListItem li = (ListItem)model.getElementAt(i);
	  // If the executable is default one, truncate it...
	  if (li.getValue().endsWith(" (DEFAULT)")) {
	    int DEFAULT = li.getValue().indexOf(" (DEFAULT)");

	    path[i] = li.getValue().substring(0, DEFAULT).trim();

            /*defaultXmame = i;*/

	    config.add("xmame.default_executable_file", i);
	  }
	  else {
	    path[i] = li.getValue();
	  }
        }

        config.add("xmame.number_of_executable_files", xmameExec.length);
      }
      else {
        config.add("xmame.default_executable_file", -1);
        config.add("xmame.number_of_executable_files", 0);
      }

      Object[] romDir = model2.toArray();
      String[] dir = null;

      if (romDir.length > 0) {
        dir = new String[romDir.length];

        for (int i = 0; i < romDir.length; i++) {
	  ListItem li = (ListItem)model2.getElementAt(i);
	  dir[i] = li.getValue();
	}

	config.add("xmame.number_of_rom_dirs", romDir.length);
      }

      //****** Save xmame parameters
      String[] params  = {
                         "xmame.executable_file",
                         "xmame.rom_dir",
                         "xmame.snap_dir",
                         "xmame.flyer_dir",
                         "xmame.marquee_dir",
                         "xmame.cabinet_dir",
			 "xmame.sample_dir",
			 "xmame.artwork_dir",
                         "xmame.ini_dir",
			 "xmame.cfg_dir",
			 "xmame.nvram_dir",
			 "xmame.memcard_dir",
			 "xmame.input_dir",
			 "xmame.state_dir",
			 "xmame.diff_dir",
			 "xmame.ctrlr_dir",
			 "xmame.cheat.dat_path",
			 "xmame.hiscore.dat_path",
			 "xmame.history.dat_path",
			 "xmame.mameinfo.dat_path",
			 "xmame.catver.ini_path",
                         "mysql.user",
                         "mysql.passwd",
                         "mysql.hostname",
                         "User.name",
                         "User.mail",
                         "User.smtp",
			 "User.browser",
                         "xmame.rom_server",
			 "xmame.snap_server",
                         "xmame.flyer_server",
			 "xmame.marquee_server",
			 "xmame.cabinet_server",
			 "xmame.sample_server",
			 "xmame.artwork_server"
			 };

      String[] values = {
                         utils.concatenateValues(path, ";"),
                         utils.concatenateValues(dir, ";"),
                         snapField.getText(),
                         flyerField.getText(),
                         marqueeField.getText(),
                         cabinetField.getText(),
			 sampleField.getText(),
			 artworkField.getText(),
                         iniField.getText(),
			 cfgField.getText(),
			 nvramField.getText(),
			 memcardField.getText(),
			 inputField.getText(),
			 stateField.getText(),
			 diffField.getText(),
			 ctrlrField.getText(),
			 cheatField.getText(),
			 hiscoreField.getText(),
			 historyField.getText(),
			 mameinfoField.getText(),
			 catverField.getText(),
                         mysqlUser.getText(),
                         new String(mysqlPasswd.getPassword()),
                         mysqlHostname.getText(),
                         nameField.getText(),
                         mailField.getText(),
                         smtpField.getText(),
			 browserField.getText(),
                         downRomsField.getText(),
			 server.getItemAt(0).toString().trim(),
			 server.getItemAt(1).toString().trim(),
			 server.getItemAt(2).toString().trim(),
			 server.getItemAt(3).toString().trim(),
			 downSampleField.getText(),
			 downArtworkField.getText()
			 };

      for (int i = 0; i < values.length; i++) {
        config.add(params[i], values[i]);
      }

      /*
      if (aP0.getRadioButton().isSelected())
        config.add("data_storing_type", 0);
      else if (aP1.getRadioButton().isSelected())
        config.add("data_storing_type", 1);
      else if (aP2.getRadioButton().isSelected())
        config.add("data_storing_type", 2);
      else
        config.add("data_storing_type", 0);
      */

      if (xmlButton.isSelected())
        config.add("data_storing_type", 0);
      else if (sqlButton.isSelected())
        config.add("data_storing_type", 1);
      else if (txtButton.isSelected())
        config.add("data_storing_type", 2);
      else
        config.add("data_storing_type", 0);

      // Write configuration file
      config.save();

      // Update main window' s combo box with new items
      if (path != null) {
        ActionListener[] al = romeo.games.xmameComboBox.getActionListeners();

	for (int i = 0; i < al.length; i++) {
          romeo.games.xmameComboBox.removeActionListener(al[i]);
	}

        // Get number of items in the list
        int count = romeo.games.xmameComboBox.getItemCount();

        // If count > 0 removes all items
        if (count > 0)
          romeo.games.xmameComboBox.removeAllItems();

	for (int i = 0; i < path.length; i++) {
	  // Add item to the combo box
	  romeo.games.xmameComboBox.addItem(path[i]);
	}

	for (int i = 0; i < al.length; i++) {
          romeo.games.xmameComboBox.addActionListener(al[i]);
	}

	/*romeo.games.xmameComboBox.setSelectedIndex(defaultXmame);*/
      }
      else {
        ActionListener[] al = romeo.games.xmameComboBox.getActionListeners();

	for (int i = 0; i < al.length; i++) {
          romeo.games.xmameComboBox.removeActionListener(al[i]);
	}

	romeo.games.xmameComboBox.removeAllItems();

	romeo.games.xmameComboBox.addItem("<NOT SET>");

	for (int i = 0; i < al.length; i++) {
          romeo.games.xmameComboBox.addActionListener(al[i]);
	}

        romeo.games.xmameComboBox.setSelectedIndex(0);
      }

      // dispose
      dispose();
    }
  }

  /**
   * Exit without saving.
   */
  public class CancelAction implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      // Simply dispose...
      dispose();
    }
  }
}

/**
 *  Copyright 1999-2002 Matthew Robinson and Pavel Vorobiev.
 *  All Rights Reserved.
 *
 *  ===================================================
 *  This program contains code from the book "Swing"
 *  2nd Edition by Matthew Robinson and Pavel Vorobiev
 *  http://www.spindoczine.com/sbe
 *  ===================================================
 *
 *  The above paragraph must be included in full, unmodified
 *  and completely intact in the beginning of any source code
 *  file that references, copies or uses (in any way, shape
 *  or form) code contained in this file.
 */

/**
 * Combo box renderer.
 *
 * @since 0.1.3pre1
 */
class ComboBoxRenderer extends JLabel implements ListCellRenderer {
  public static final int OFFSET = 16;

  protected Color m_textSelectionColor = Color.white;
  protected Color m_textNonSelectionColor = Color.black;
  protected Color m_textNonselectableColor = Color.gray;
  protected Color m_bkSelectionColor = new Color(0, 0, 128);
  protected Color m_bkNonSelectionColor = Color.white;
  protected Color m_borderSelectionColor = Color.yellow;

  protected Color  m_textColor;
  protected Color  m_bkColor;

  protected boolean m_hasFocus;
  protected Border[] m_borders;

  protected JComboBox cb = null;

  protected ImageIcon icon = null;

  Utils utils = new Utils();

  public ComboBoxRenderer(JComboBox cb, ImageIcon icon) {
    super();
    this.cb = cb;
    this.icon = icon;
    m_textColor = m_textNonSelectionColor;
    m_bkColor = m_bkNonSelectionColor;
    m_borders = new Border[20];
    for (int k = 0; k < m_borders.length; k++)
      m_borders[k] = new EmptyBorder(0, OFFSET*k, 0, 0);
    setOpaque(false);
  }

  public Component getListCellRendererComponent(JList list, Object obj,
                                                int row, boolean sel,
                                                boolean hasFocus) {
    if (obj == null)
      return this;
    setText(obj.toString());
    boolean selectable = true;
    if (obj.toString().length() > 0) {
      setIcon(icon);
      int index = 0;
      if (row >= 0)	// no offset for text field (row=-1)
        index = cb.getSelectedIndex();
      Border b = (index < m_borders.length ? m_borders[index] :
	          new EmptyBorder(0, OFFSET*index, 0, 0));
      setBorder(b);
    }
    else
      setIcon(null);

    setFont(list.getFont());
    m_textColor = (sel ? m_textSelectionColor :
	          (selectable ? m_textNonSelectionColor :
	           m_textNonselectableColor));
    m_bkColor = (sel ? m_bkSelectionColor : m_bkNonSelectionColor);
    m_hasFocus = hasFocus;
    return this;
  }

  public void paint(Graphics g) {
    Icon icon = getIcon();
    Border b = getBorder();

    g.setColor(m_bkNonSelectionColor);
    g.fillRect(0, 0, getWidth(), getHeight());

    g.setColor(m_bkColor);
    int offset = 0;
    if  (icon != null && getText() != null) {
      Insets ins = getInsets();
      offset = ins.left + icon.getIconWidth() + getIconTextGap();
    }
    g.fillRect(offset, 0, getWidth() - 1 - offset, getHeight() - 1);

    if (m_hasFocus) {
      g.setColor(m_borderSelectionColor);
      g.drawRect(offset, 0, getWidth()-1-offset, getHeight()-1);
    }

    setForeground(m_textColor);
    setBackground(m_bkColor);

    super.paint(g);
  }
}

